;LD.pbi, 07.12.2008
;hier auch Macros von Tests drin
;==================================================================================================
Macro M_XMM_XMM_Z()                         ;XMM-Register auf 0 setzen
  !pxor xmm0,xmm0
  !movdqa xmm1,xmm0
  !movdqa xmm2,xmm0
  !movdqa xmm3,xmm0
  !movdqa xmm4,xmm0
  !movdqa xmm5,xmm0
  !movdqa xmm6,xmm0
  !movdqa xmm7,xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_XMM(Befehl)                    ;Macro Latenz XMM - XMM-Register
  !Befehl xmm0,xmm7                         ;Einge Beispiele:
  !Befehl xmm1,xmm0                         ; DIVPD, DIVSD, MOVDQA, MOVDQU, MULPD, MULSD, ... 
  !Befehl xmm2,xmm1
  !Befehl xmm3,xmm2
  !Befehl xmm4,xmm3
  !Befehl xmm5,xmm4  
  !Befehl xmm6,xmm5
  !Befehl xmm7,xmm6
EndMacro 
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_XMM(Befehl)                    ;Macro Durchsatz XMM - XMM-Register
  !Befehl xmm0,xmm1
  !Befehl xmm2,xmm3  
  !Befehl xmm4,xmm5
  !Befehl xmm6,xmm7
  !Befehl xmm0,xmm1
  !Befehl xmm2,xmm3  
  !Befehl xmm4,xmm5
  !Befehl xmm6,xmm7
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_XMM_XMM0(Befehl)               ;Macro Latenz XMM - XMM - XMM0-Register
  !Befehl xmm6,xmm7,xmm0                    ;Einge Beispiele:
  !Befehl xmm1,xmm6,xmm0                    ; BLENDVPS ... 
  !Befehl xmm2,xmm1,xmm0
  !Befehl xmm3,xmm2,xmm0
  !Befehl xmm4,xmm3,xmm0
  !Befehl xmm5,xmm4,xmm0  
  !Befehl xmm6,xmm5,xmm0
  !Befehl xmm7,xmm6,xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_XMM_XMM0(Befehl)               ;Macro Durchsatz XMM - XMM - XMM0-Register
  !Befehl xmm2,xmm1,xmm0
  !Befehl xmm4,xmm3,xmm0  
  !Befehl xmm6,xmm5,xmm0
  !Befehl xmm2,xmm7,xmm0
  !Befehl xmm4,xmm1,xmm0
  !Befehl xmm6,xmm3,xmm0  
  !Befehl xmm2,xmm5,xmm0
  !Befehl xmm4,xmm7,xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_MEM128(Befehl)                 ;Macro Latenz XMM-Register - 128-Bit-Speicher
  !Befehl xmm0,dqword[esi];                  ;Einge Beispiele:
  !Befehl xmm0,dqword[esi+16]               ; DIVPD, DIVSD, MOVDQA, MOVDQU, MULPD, MULSD, ... 
  !Befehl xmm0,dqword[esi+32]
  !Befehl xmm0,dqword[esi+48]
  !Befehl xmm0,dqword[esi+64]
  !Befehl xmm0,dqword[esi+80]  
  !Befehl xmm0,dqword[esi+96]
  !Befehl xmm0,dqword[esi+112]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_MEM128(Befehl)                 ;Macro Durchsatz XMM-Register - 128-Bit-Speicher
  !Befehl xmm0,dqword[esi]
  !Befehl xmm1,dqword[esi+16]  
  !Befehl xmm2,dqword[esi+32]
  !Befehl xmm3,dqword[esi+48]
  !Befehl xmm4,dqword[esi+64]
  !Befehl xmm5,dqword[esi+80]  
  !Befehl xmm6,dqword[esi+96]
  !Befehl xmm7,dqword[esi+112]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_MEM128U(Befehl)                ;Macro Latenz XMM-Register - 128-Bit-Speicher (Non-Alignment)
  !Befehl xmm0,dqword[esi+289]              ;Einge Beispiele:
  !Befehl xmm0,dqword[esi+305]              ; MOVDQU, MOVUPD, MOVUPS 
  !Befehl xmm0,dqword[esi+321]
  !Befehl xmm0,dqword[esi+337]
  !Befehl xmm0,dqword[esi+353]
  !Befehl xmm0,dqword[esi+369]  
  !Befehl xmm0,dqword[esi+385]
  !Befehl xmm0,dqword[esi+401]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_MEM128U(Befehl)                ;Macro Durchsatz XMM-Register - 128-Bit-Speicher (Non-Alignment)
  !Befehl xmm0,dqword[esi+289]
  !Befehl xmm1,dqword[esi+305]  
  !Befehl xmm2,dqword[esi+321]
  !Befehl xmm3,dqword[esi+337]
  !Befehl xmm4,dqword[esi+353]
  !Befehl xmm5,dqword[esi+369]  
  !Befehl xmm6,dqword[esi+385]
  !Befehl xmm7,dqword[esi+401]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM128U_XMM(Befehl)                ;Macro Latenz XMM-Register - 128-Bit-Speicher (Non-Alignment)
  !Befehl dqword[esi+289],xmm0              ;Einge Beispiele:
  !Befehl dqword[esi+305],xmm0              ; MOVDQU, MOVUPD, MOVUPS 
  !Befehl dqword[esi+321],xmm0
  !Befehl dqword[esi+337],xmm0
  !Befehl dqword[esi+353],xmm0
  !Befehl dqword[esi+369],xmm0  
  !Befehl dqword[esi+385],xmm0
  !Befehl dqword[esi+401],xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM128U_XMM(Befehl)                ;Macro Durchsatz XMM-Register - 128-Bit-Speicher (Non-Alignment)
  !Befehl dqword[esi+289],xmm0
  !Befehl dqword[esi+305],xmm1  
  !Befehl dqword[esi+321],xmm2
  !Befehl dqword[esi+337],xmm3
  !Befehl dqword[esi+353],xmm4
  !Befehl dqword[esi+369],xmm5  
  !Befehl dqword[esi+385],xmm6
  !Befehl dqword[esi+401],xmm7
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_MEM128_XMM0(Befehl)            ;Macro Latenz XMM-Register - 128-Bit-Speicher
  !Befehl xmm1,dqword[esi],xmm0             ;Einge Beispiele:
  !Befehl xmm1,dqword[esi+16],xmm0          ; BLENDVPS ...
  !Befehl xmm1,dqword[esi+32],xmm0 
  !Befehl xmm1,dqword[esi+48],xmm0
  !Befehl xmm1,dqword[esi+64],xmm0
  !Befehl xmm1,dqword[esi+80],xmm0  
  !Befehl xmm1,dqword[esi+96],xmm0
  !Befehl xmm1,dqword[esi+112],xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_MEM128_XMM0(Befehl)            ;Macro Durchsatz XMM-Register - 128-Bit-Speicher
  !Befehl xmm1,dqword[esi],xmm0
  !Befehl xmm2,dqword[esi+16],xmm0  
  !Befehl xmm3,dqword[esi+32],xmm0
  !Befehl xmm4,dqword[esi+48],xmm0
  !Befehl xmm5,dqword[esi+64],xmm0
  !Befehl xmm6,dqword[esi+80],xmm0  
  !Befehl xmm7,dqword[esi+96],xmm0
  !Befehl xmm1,dqword[esi+112],xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_MEM64(Befehl)                  ;Macro Latenz XMM-Register - 64-Bit-Speicher
  !Befehl xmm0,qword[esi]                   ;Einge Beispiele:
  !Befehl xmm0,qword[esi+8]                 ; ADDPS 
  !Befehl xmm0,qword[esi+16]
  !Befehl xmm0,qword[esi+24]
  !Befehl xmm0,qword[esi+32]
  !Befehl xmm0,qword[esi+40]  
  !Befehl xmm0,qword[esi+48]
  !Befehl xmm0,qword[esi+56]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_MEM64(Befehl)                  ;Macro Durchsatz XMM-Register - 64-Bit-Speicher
  !Befehl xmm0,qword[esi]
  !Befehl xmm1,qword[esi+8]  
  !Befehl xmm2,qword[esi+16]
  !Befehl xmm3,qword[esi+24]
  !Befehl xmm4,qword[esi+32]
  !Befehl xmm5,qword[esi+40]  
  !Befehl xmm6,qword[esi+48]
  !Befehl xmm7,qword[esi+56]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM64_XMM(Befehl)                  ;Macro Latenz 64-Bit-Speicher - XMM-Register
  !Befehl qword[esi+128],xmm0               ;Einge Beispiele:
  !Befehl qword[esi+136],xmm0               ; MOVHPD
  !Befehl qword[esi+144],xmm0
  !Befehl qword[esi+152],xmm0
  !Befehl qword[esi+160],xmm0
  !Befehl qword[esi+168],xmm0  
  !Befehl qword[esi+176],xmm0
  !Befehl qword[esi+184],xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM64_XMM(Befehl)                  ;Macro Durchsatz 64-Bit-Speicher - XMM-Register
  !Befehl qword[esi+128],xmm0
  !Befehl qword[esi+136],xmm1  
  !Befehl qword[esi+144],xmm2
  !Befehl qword[esi+152],xmm3
  !Befehl qword[esi+160],xmm4
  !Befehl qword[esi+168],xmm5  
  !Befehl qword[esi+176],xmm6
  !Befehl qword[esi+184],xmm7
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_MEM64_IMMFEST(Befehl, Wert)    ;Macro Latenz XMM - 64-Bit-Speicher - Wert
  !Befehl xmm0,qword[esi],Wert              ;Einge Beispiele:
  !Befehl xmm0,qword[esi+8],Wert            ; CMPSD 
  !Befehl xmm0,qword[esi+16],Wert
  !Befehl xmm0,qword[esi+24],Wert
  !Befehl xmm0,qword[esi+32],Wert
  !Befehl xmm0,qword[esi+40],Wert  
  !Befehl xmm0,qword[esi+48],Wert
  !Befehl xmm0,qword[esi+56],Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_MEM64_IMMFEST(Befehl, Wert)    ;Macro Durchsatz XMM-Register - 64-Bit-Speicher - Wert
  !Befehl xmm0,qword[esi],Wert
  !Befehl xmm1,qword[esi+8],Wert  
  !Befehl xmm2,qword[esi+16],Wert
  !Befehl xmm3,qword[esi+24],Wert
  !Befehl xmm4,qword[esi+32],Wert
  !Befehl xmm5,qword[esi+40],Wert  
  !Befehl xmm6,qword[esi+48],Wert
  !Befehl xmm7,qword[esi+56],Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_REG32(Befehl)                  ;Macro Latenz XMM-Register - 32-Bit-Register
  !Befehl xmm0,edx                          ;Einge Beispiele:
  !Befehl xmm0,eax                          ; MOVD 
  !Befehl xmm0,ebx
  !Befehl xmm0,ecx
  !Befehl xmm0,edx
  !Befehl xmm0,eax  
  !Befehl xmm0,ebx
  !Befehl xmm0,ecx
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_REG32(Befehl)                  ;Macro Durchsatz XMM-Register - 32-Bit-Register
  !Befehl xmm0,ebp
  !Befehl xmm1,ebp  
  !Befehl xmm2,ebp
  !Befehl xmm3,ebp
  !Befehl xmm4,ebp
  !Befehl xmm5,ebp  
  !Befehl xmm6,ebp
  !Befehl xmm7,ebp
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_REG32_XMM(Befehl)                  ;Macro Latenz 32-Bit-Register - XMM-Register
  !Befehl edx,xmm0                          ;Einge Beispiele:
  !Befehl eax,xmm0                          ; MOVD 
  !Befehl ebx,xmm0
  !Befehl ecx,xmm0
  !Befehl edx,xmm0
  !Befehl eax,xmm0  
  !Befehl ebx,xmm0
  !Befehl ecx,xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_REG32_XMM(Befehl)                  ;Macro Durchsatz 32-Bit-Register - XMM-Register
  !Befehl eax,xmm0                          ;zum Test nicht EBP 
  !Befehl eax,xmm1  
  !Befehl ebx,xmm2
  !Befehl ecx,xmm3
  !Befehl edx,xmm4
  !Befehl eax,xmm5  
  !Befehl ebx,xmm6
  !Befehl ecx,xmm7
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM32_XMM(Befehl)                  ;Macro Latenz 32-Bit-Speicher - XMM-Register
  !Befehl dword[esi+128],xmm0               ;Einge Beispiele:
  !Befehl dword[esi+132],xmm0               ; MOVD 
  !Befehl dword[esi+136],xmm0
  !Befehl dword[esi+140],xmm0
  !Befehl dword[esi+144],xmm0
  !Befehl dword[esi+148],xmm0  
  !Befehl dword[esi+152],xmm0
  !Befehl dword[esi+156],xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM32_XMM(Befehl)                  ;Macro Durchsatz 32-Bit-Speicher - XMM-Register
  !Befehl dword[esi+128],xmm0               ;zum Test hier mal nicht EBP 
  !Befehl dword[esi+132],xmm1  
  !Befehl dword[esi+136],xmm2
  !Befehl dword[esi+140],xmm3
  !Befehl dword[esi+144],xmm4
  !Befehl dword[esi+148],xmm5  
  !Befehl dword[esi+152],xmm6
  !Befehl dword[esi+156],xmm7
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_MEM32(Befehl)                  ;Macro Latenz XMM-Register - 32-Bit-Speicher
  !Befehl xmm0,dword[esi+256]               ;Einge Beispiele:
  !Befehl xmm0,dword[esi+260]               ; ADDPS 
  !Befehl xmm0,dword[esi+264]
  !Befehl xmm0,dword[esi+268]
  !Befehl xmm0,dword[esi+272]
  !Befehl xmm0,dword[esi+276]  
  !Befehl xmm0,dword[esi+280]
  !Befehl xmm0,dword[esi+284]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_MEM32(Befehl)                  ;Macro Durchsatz XMM-Register - 32-Bit-Speicher
  !Befehl xmm0,dword[esi+256] 
  !Befehl xmm1,dword[esi+260]  
  !Befehl xmm2,dword[esi+264]
  !Befehl xmm3,dword[esi+268]
  !Befehl xmm4,dword[esi+272]
  !Befehl xmm5,dword[esi+276]  
  !Befehl xmm6,dword[esi+280]
  !Befehl xmm7,dword[esi+284]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_MEM32_IMMFEST(Befehl, Wert)    ;Macro Latenz XMM-Register - 32-Bit-Speicher - Wert
  !Befehl xmm0,dword[esi+256],Wert          ;Einge Beispiele:
  !Befehl xmm0,dword[esi+260],Wert          ; CMPSS
  !Befehl xmm0,dword[esi+264],Wert
  !Befehl xmm0,dword[esi+268],Wert
  !Befehl xmm0,dword[esi+272],Wert
  !Befehl xmm0,dword[esi+276],Wert  
  !Befehl xmm0,dword[esi+280],Wert
  !Befehl xmm0,dword[esi+284],Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_MEM32_IMMFEST(Befehl, Wert)    ;Macro Durchsatz XMM-Register - 32-Bit-Speicher - Wert
  !Befehl xmm0,dword[esi+256],Wert
  !Befehl xmm1,dword[esi+260],Wert  
  !Befehl xmm2,dword[esi+264],Wert
  !Befehl xmm3,dword[esi+268],Wert
  !Befehl xmm4,dword[esi+272],Wert
  !Befehl xmm5,dword[esi+276],Wert  
  !Befehl xmm6,dword[esi+280],Wert
  !Befehl xmm7,dword[esi+284],Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM128_XMM(Befehl)                 ;Macro Latenz 128-Bit-Speicher - XMM-Register
  !Befehl dqword[esi+128],xmm0              ;Einge Beispiele:
  !Befehl dqword[esi+144],xmm0              ; DIVPD, DIVSD, MOVDQA, MOVDQU, MULPD, MULSD, ... 
  !Befehl dqword[esi+160],xmm0
  !Befehl dqword[esi+176],xmm0
  !Befehl dqword[esi+192],xmm0
  !Befehl dqword[esi+208],xmm0  
  !Befehl dqword[esi+224],xmm0
  !Befehl dqword[esi+240],xmm0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM128_XMM(Befehl)                 ;Macro Durchsatz 128-Bit-Speicher - XMM-Register
  !Befehl dqword[esi+128],xmm0
  !Befehl dqword[esi+144],xmm1  
  !Befehl dqword[esi+160],xmm2
  !Befehl dqword[esi+176],xmm3
  !Befehl dqword[esi+192],xmm4
  !Befehl dqword[esi+208],xmm5 
  !Befehl dqword[esi+224],xmm6
  !Befehl dqword[esi+240],xmm7
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_XMM_IMMFEST(Befehl, Wert)      ;Macro Latenz XMM - XMM-Register - Wert
  !Befehl xmm0,xmm7,Wert                    ;Einge Beispiele:
  !Befehl xmm1,xmm0,Wert                    ; DPPD, DPPS, PBLENDW, PSHUFD
  !Befehl xmm2,xmm1,Wert
  !Befehl xmm3,xmm2,Wert
  !Befehl xmm4,xmm3,Wert
  !Befehl xmm5,xmm4,Wert  
  !Befehl xmm6,xmm5,Wert
  !Befehl xmm7,xmm6,Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_XMM_IMMFEST(Befehl, Wert)      ;Macro Durchsatz XMM - XMM-Register - Wert
  !Befehl xmm0,xmm1,Wert
  !Befehl xmm2,xmm3,Wert  
  !Befehl xmm4,xmm5,Wert
  !Befehl xmm6,xmm7,Wert
  !Befehl xmm0,xmm1,Wert
  !Befehl xmm2,xmm3,Wert  
  !Befehl xmm4,xmm5,Wert
  !Befehl xmm6,xmm7,Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_MEM128_IMMFEST(Befehl, Wert)   ;Macro Latenz XMM - 128-Bit-Speicher - Wert
  !Befehl xmm0,dqword[esi],Wert             ;Einge Beispiele:
  !Befehl xmm0,dqword[esi+16],Wert          ; DPPD, DPPS, PBLENDW, PSHUFD
  !Befehl xmm0,dqword[esi+32],Wert
  !Befehl xmm0,dqword[esi+48],Wert
  !Befehl xmm0,dqword[esi+64],Wert
  !Befehl xmm0,dqword[esi+80],Wert  
  !Befehl xmm0,dqword[esi+96],Wert
  !Befehl xmm0,dqword[esi+112],Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_MEM128_IMMFEST(Befehl, Wert)   ;Macro Durchsatz XMM - 128-Bit-Speicher - Wert
  !Befehl xmm0,dqword[esi],Wert
  !Befehl xmm1,dqword[esi+16],Wert  
  !Befehl xmm2,dqword[esi+32],Wert
  !Befehl xmm3,dqword[esi+48],Wert
  !Befehl xmm4,dqword[esi+64],Wert
  !Befehl xmm5,dqword[esi+80],Wert  
  !Befehl xmm6,dqword[esi+96],Wert
  !Befehl xmm7,dqword[esi+112],Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_XMM_IMMFEST(Befehl, Wert)          ;Macro Latenz XMM - Wert
  !Befehl xmm0,Wert                         ;Einge Beispiele:
  !Befehl xmm0,Wert                         ; PSLLD
  !Befehl xmm0,Wert
  !Befehl xmm0,Wert
  !Befehl xmm0,Wert
  !Befehl xmm0,Wert  
  !Befehl xmm0,Wert
  !Befehl xmm0,Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_XMM_IMMFEST(Befehl, Wert)          ;Macro Durchsatz XMM - Wert
  !Befehl xmm0,Wert
  !Befehl xmm1,Wert  
  !Befehl xmm2,Wert
  !Befehl xmm3,Wert
  !Befehl xmm4,Wert
  !Befehl xmm5,Wert  
  !Befehl xmm6,Wert
  !Befehl xmm7,Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_REG32_REG32(Befehl)                ;Macro Latenz 32-Bit-Register - 32-Bit-Register
  !Befehl eax,edx                           ;Einige Beispiele:
  !Befehl ebx,eax                           ; ADC, ADD, AND, BSF, BSR, CMOVcc, CMP, CMPXCHG
  !Befehl ecx,ebx                           ; IMUL, MOV, OR, SBB, SUB, TEST, XADD, XCHG, XOR 
  !Befehl edx,ecx
  !Befehl eax,edx
  !Befehl ebx,eax
  !Befehl ecx,ebx
  !Befehl edx,ecx
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_REG32_REG32(Befehl)                ;Macro Durchsatz 32-Bit-Register - 32-Bit-Register
  !Befehl eax,ebp 
  !Befehl ebx,ebp
  !Befehl ecx,ebp
  !Befehl edx,ebp  
  !Befehl eax,ebp
  !Befehl ebx,ebp  
  !Befehl ecx,ebp
  !Befehl edx,ebp  
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_REG32_REG8(Befehl)                 ;Macro Latenz 32-Bit-Register - 8-Bit-Register
  !Befehl eax,cl                            ;Einige Beispiele:
  !Befehl eax,cl                            ; MOVSX, MOVZX, RCL...
  !Befehl eax,cl
  !Befehl eax,cl
  !Befehl eax,cl
  !Befehl eax,cl
  !Befehl eax,cl
  !Befehl eax,cl
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_REG32_REG8(Befehl)                 ;Macro Durchsatz 32-Bit-Register - 8-Bit-Register
  !Befehl eax,cl
  !Befehl ebx,cl
  !Befehl ecx,cl
  !Befehl edx,cl  
  !Befehl eax,cl
  !Befehl ebx,cl  
  !Befehl ecx,cl
  !Befehl edx,cl  
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM32_REG8(Befehl)                 ;Macro Latenz 32-Bit-Speicher - 8-Bit-Register
  !Befehl dword[esi+464],cl                 ;Einige Beispiele:
  !Befehl dword[esi+464],cl                 ; MOVSX, MOVZX, RCL...
  !Befehl dword[esi+464],cl
  !Befehl dword[esi+464],cl
  !Befehl dword[esi+464],cl
  !Befehl dword[esi+464],cl
  !Befehl dword[esi+464],cl
  !Befehl dword[esi+464],cl
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM32_REG8(Befehl)                 ;Macro Durchsatz 32-Bit-Speicher - 8-Bit-Register
  !Befehl dword[esi+464],cl
  !Befehl dword[esi+468],cl
  !Befehl dword[esi+472],cl
  !Befehl dword[esi+476],cl  
  !Befehl dword[esi+480],cl
  !Befehl dword[esi+484],cl  
  !Befehl dword[esi+488],cl
  !Befehl dword[esi+492],cl  
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_REG32_MEM32(Befehl)                ;Macro Latenz 32-Bit-Register - 32-Bit-Speicher
  !Befehl eax,dword[esi+432]
  !Befehl eax,dword[esi+436]
  !Befehl eax,dword[esi+440]
  !Befehl eax,dword[esi+444]
  !Befehl eax,dword[esi+448]
  !Befehl eax,dword[esi+452]
  !Befehl eax,dword[esi+456]
  !Befehl eax,dword[esi+460]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_REG32_MEM32(Befehl)                ;Macro Durchsatz 32-Bit-Register - 32-Bit-Speicher
  !Befehl eax,dword[esi+432]
  !Befehl ebx,dword[esi+436]
  !Befehl ecx,dword[esi+440]
  !Befehl edx,dword[esi+444]  
  !Befehl eax,dword[esi+448]
  !Befehl ebx,dword[esi+452]  
  !Befehl ecx,dword[esi+456]
  !Befehl edx,dword[esi+460]  
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM32_REG32(Befehl)                ;Macro Latenz 32-Bit-Speicher - 32-Bit-Register
  !Befehl dword[esi+464],eax 
  !Befehl dword[esi+468],eax
  !Befehl dword[esi+472],eax
  !Befehl dword[esi+476],eax
  !Befehl dword[esi+480],eax
  !Befehl dword[esi+484],eax
  !Befehl dword[esi+488],eax
  !Befehl dword[esi+492],eax
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM32_REG32(Befehl)                ;Macro Durchsatz 32-Bit-Speicher - 32-Bit-Register
  !Befehl dword[esi+464],eax
  !Befehl dword[esi+468],ebx
  !Befehl dword[esi+472],ecx
  !Befehl dword[esi+476],edx  
  !Befehl dword[esi+480],eax
  !Befehl dword[esi+484],ebx  
  !Befehl dword[esi+488],ecx
  !Befehl dword[esi+492],edx  
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_REG32_IMMVAR(Befehl)               ;Macro Latenz 32-Bit-Register - Festwert
  !Befehl eax,1                             ;Einige Beispiele:
  !Befehl eax,2                             ; (RCL, RCR, ROL, ROR, SAL, SAR, SHL, SHR) dafr besser REG32_IMMFEST
  !Befehl eax,3                             ; ADD, ADC, CMP, IMUL, MOV, SBB, SUB
  !Befehl eax,4
  !Befehl eax,5
  !Befehl eax,6
  !Befehl eax,7
  !Befehl eax,8
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_REG32_IMMVAR(Befehl)               ;Macro Durchsatz 32-Bit-Register - Festwert
  !Befehl eax,1
  !Befehl ebx,2
  !Befehl ecx,3
  !Befehl edx,4
  !Befehl eax,5
  !Befehl ebx,6
  !Befehl ecx,7
  !Befehl edx,8
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM32_IMMVAR(Befehl)               ;Macro Latenz 32-Bit-Speicher - Festwert
  !Befehl dword[esi+464],1                  ;Einige Beispiele:
  !Befehl dword[esi+464],2                  ; (RCL, RCR, ROL, ROR, SAL, SAR, SHL, SHR) dafr besser REG32_IMMFEST
  !Befehl dword[esi+464],3                  ; ADD, ADC, CMP, IMUL, MOV, SBB, SUB
  !Befehl dword[esi+464],4
  !Befehl dword[esi+464],5
  !Befehl dword[esi+464],6
  !Befehl dword[esi+464],7
  !Befehl dword[esi+464],8
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM32_IMMVAR(Befehl)               ;Macro Durchsatz 32-Bit-Speicher - Festwert
  !Befehl dword[esi+464],1
  !Befehl dword[esi+468],2
  !Befehl dword[esi+472],3
  !Befehl dword[esi+476],4
  !Befehl dword[esi+480],5
  !Befehl dword[esi+484],6
  !Befehl dword[esi+488],7
  !Befehl dword[esi+492],8
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_REG32_IMMFEST(Befehl, Wert)        ;Macro Latenz 32-Bit-Register - Festwert
  !Befehl eax,Wert                          ;Einige Beispiele:
  !Befehl eax,Wert                          ; RCL, RCR, ROL, ROR, SAL, SAR, SHL, SHR
  !Befehl eax,Wert                          ; ADD, ADC, CMP, IMUL, MOV, SBB, SUB
  !Befehl eax,Wert
  !Befehl eax,Wert
  !Befehl eax,Wert
  !Befehl eax,Wert
  !Befehl eax,Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_REG32_IMMFEST(Befehl, Wert)        ;Macro Durchsatz 32-Bit-Register - Festwert
  !Befehl eax,Wert
  !Befehl ebx,Wert
  !Befehl ecx,Wert
  !Befehl edx,Wert
  !Befehl eax,Wert
  !Befehl ebx,Wert
  !Befehl ecx,Wert
  !Befehl edx,Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM32_IMMFEST(Befehl, Wert)        ;Macro Latenz 32-Bit-Speicher - Festwert
  !Befehl dword[esi+464],Wert               ;Einige Beispiele:
  !Befehl dword[esi+464],Wert               ; RCL, RCR, ROL, ROR, SAL, SAR, SHL, SHR
  !Befehl dword[esi+464],Wert               ; ADD, ADC, CMP, IMUL, MOV, SBB, SUB
  !Befehl dword[esi+464],Wert
  !Befehl dword[esi+464],Wert
  !Befehl dword[esi+464],Wert
  !Befehl dword[esi+464],Wert
  !Befehl dword[esi+464],Wert
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM32_IMMFEST(Befehl, Wert)        ;Macro Durchsatz 32-Bit-Speicher - Festwert
  !Befehl dword[esi+464],Wert
  !Befehl dword[esi+468],Wert
  !Befehl dword[esi+472],Wert
  !Befehl dword[esi+476],Wert
  !Befehl dword[esi+480],Wert
  !Befehl dword[esi+484],Wert
  !Befehl dword[esi+488],Wert
  !Befehl dword[esi+492],Wert
EndMacro

;--------------------------------------------------------------------------------------------------
Macro ML_REG32(Befehl)                      ;Macro Latenz 32-Bit-Register
  !Befehl eax                               ;Einige Beispiele:
  !Befehl eax                               ; BSWAP, DEC, IMUL, INC, MUL, NEG, NOT
  !Befehl eax
  !Befehl eax
  !Befehl eax
  !Befehl eax
  !Befehl eax
  !Befehl eax
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_REG32(Befehl)                      ;Macro Durchsatz 32-Bit-Register
  !Befehl eax
  !Befehl ebx
  !Befehl ecx
  !Befehl edx 
  !Befehl edi
  !Befehl esi 
  !Befehl ebp
  !Befehl eax 
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_MEM32(Befehl)                      ;Macro Latenz 32-Bit-Speicher
  !Befehl dword[esi+464]                    ;Einige Beispiele:
  !Befehl dword[esi+464]                    ; DEC, INC, NEG, NOT
  !Befehl dword[esi+464]
  !Befehl dword[esi+464]
  !Befehl dword[esi+464]
  !Befehl dword[esi+464]
  !Befehl dword[esi+464]
  !Befehl dword[esi+464]
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_MEM32(Befehl)                      ;Macro Durchsatz 32-Bit-Speicher
  !Befehl dword[esi+464]
  !Befehl dword[esi+468]
  !Befehl dword[esi+472]
  !Befehl dword[esi+476] 
  !Befehl dword[esi+480]
  !Befehl dword[esi+484] 
  !Befehl dword[esi+488]
  !Befehl dword[esi+492] 
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_(Befehl)                           ;Macro Latenz Befehl ohne Parameter
  !Befehl                                   ;Einige Beispiele:
  !Befehl                                   ; AAA
  !Befehl
  !Befehl
  !Befehl
  !Befehl
  !Befehl
  !Befehl
EndMacro
;--------------------------------------------------------------------------------------------------
Macro MD_(Befehl)                           ;Macro Durchsatz Befehl ohne Parameter
  !Befehl                                   ; vielleicht habe ich hier noch ne Idee
  !Befehl
  !Befehl
  !Befehl
  !Befehl
  !Befehl
  !Befehl
  !Befehl
EndMacro
;--------------------------------------------------------------------------------------------------
Macro F1ML_(Befehl)                         ;Macro Latenz FPU-Befehl 
  !Befehl ST0                               ;Einige Beispiele:
  !Befehl ST0                               ;
  !Befehl ST0 
  !Befehl ST0 
  !Befehl ST0 
  !Befehl ST0 
  !Befehl ST0 
  !Befehl ST0 
EndMacro
;--------------------------------------------------------------------------------------------------
Macro F1MD_(Befehl)                           ;FPU
  !Befehl ST0 
  !Befehl ST1 
  !Befehl ST2 
  !Befehl ST3 
  !Befehl ST4 
  !Befehl ST5 
  !Befehl ST0 
  !Befehl ST1 
EndMacro






;--------------------------------------------------------------------------------------------------
Macro F3ML_()                               ;Macro Latenz FPU-Befehl 
;!lea esi,[MemAli]
;!mov esi,[v_DataMem] 
  !FLD qword[esi]                           ;Einige Beispiele:
  !FFREE ST6
  !FLD qword[esi+8]
  !FFREE ST6
  !FLD qword[esi+16]
  !FFREE ST6
  !FLD qword[esi+24]
  !FFREE ST6  
  !FLD qword[esi+32]
  !FFREE ST6
  !FLD qword[esi+40]
  !FFREE ST6
  !FLD qword[esi+48]
  !FFREE ST6
  !FLD qword[esi+56]
  !FFREE ST6  
EndMacro

;--------------------------------------------------------------------------------------------------
Macro F5ML_()                               ;Macro Latenz FPU-Befehl 
  !FLD ST0                                  ;Einige Beispiele:
  !FFREE ST6                                ;
  !FLD ST0
  !FFREE ST6
  !FLD ST0
  !FFREE ST6
  !FLD ST0
  !FFREE ST6
  !FLD ST0
  !FFREE ST6
  !FLD ST0
  !FFREE ST6
  !FLD ST0
  !FFREE ST6
  !FLD ST0
  !FFREE ST6
EndMacro







;--------------------------------------------------------------------------------------------------
Macro F2ML_(Befehl)                           ;Macro Latenz FPU-Befehl 
  !Befehl ST0, ST0                                  ;Einige Beispiele:
  !Befehl ST0, ST0                                   ;
  !Befehl ST0, ST0
  !Befehl ST0, ST0
  !Befehl ST0, ST0
  !Befehl ST0, ST0
  !Befehl ST0, ST0
  !Befehl ST0, ST0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro F2MD_(Befehl)                           ;FPU
  !Befehl ST1, ST0
  !Befehl ST2, ST0
  !Befehl ST3, ST0
  !Befehl ST4, ST0
  !Befehl ST5, ST0
  !Befehl ST1, ST0
  !Befehl ST2, ST0
  !Befehl ST3, ST0
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_JUMP                               ;Macro Latenz JUMP, Sprung wird ausgefhrt
  !cmp ebp,0
  !jne @f
  !@@: 
  !cmp ebp,0
  !jne @f  
  !@@:
  !cmp ebp,0
  !jne @f  
  !@@: 
  !cmp ebp,0
  !jne @f  
  !@@: 
  !cmp ebp,0
  !jne @f  
  !@@: 
  !cmp ebp,0
  !jne @f  
  !@@: 
  !cmp ebp,0
  !jne @f 
  !@@: 
  !cmp ebp,0
  !jne @f
  !@@:
EndMacro
;--------------------------------------------------------------------------------------------------
Macro ML_NOJUMP                             ;Macro Latenz NOJUMP, Sprung wird nicht ausgefhrt
  !cmp ebp,0
  !je @f
  !@@:
  !cmp ebp,0
  !je @f  
  !@@:
  !cmp ebp,0
  !je @f  
  !@@:
  !cmp ebp,0
  !je @f  
  !@@:
  !cmp ebp,0
  !je @f  
  !@@:
  !cmp ebp,0
  !je @f  
  !@@:
  !cmp ebp,0
  !je @f 
  !@@:
  !cmp ebp,0
  !je @f
  !@@:
EndMacro
;--------------------------------------------------------------------------------------------------
Macro Messung(Latenz, Durchsatz, Beide, Proz)
ProzFPU = Proz                              ;Klimmzug wegen PB4.30, mal sehen
If CPU >= Proz Or ProzFPU = 10              ;nicht untersttzte Befehle aussieben, 10=FPU    
  CodeMem = CodeMemUr
  !mov esi,[v_DataMem]  
  !mov [v_CodeA],10                         ;Lnge des nachfolgenden Befehls
  !add [v_CodeA],$
  Latenz
  !mov eax,$    
  !sub eax,[v_CodeA]
  !mov [v_CodeL],eax
  CodeMem = CodeMemUr
  LDTicks()
  TicksL = Ticks

  TicksD = 0.00                             ;wenn Durchsatz nicht messbar       
  If Beide
    !mov esi,[v_DataMem]   
    !mov [v_CodeA],10
    !add [v_CodeA],$
    Durchsatz
    !mov eax,$    
    !sub eax,[v_CodeA]
    !mov [v_CodeL],eax
    CodeMem = CodeMemUr
    LDTicks()
    TicksD = Ticks
  EndIf 
  AddGadgetItem(0, z, I$)
  L1$ = StrD(TicksL, 2)
  L$ = Space(2 * (7 - Len(L1$))) + L1$
  D1$ = StrD(TicksD, 2)
  D$ = Space(2 * (7 - Len(D1$))) + D1$
  SetGadgetItemText(0, z, L$, 1)
  SetGadgetItemText(0, z, D$, 2)  
  Select Proz
    Case 0
      SetGadgetItemColor(0,  z, #PB_Gadget_BackColor,  $99FFFF, -1) 
    Case 1 To 7                             ;evtl. farblich aufteilen  
      SetGadgetItemColor(0,  z, #PB_Gadget_BackColor,  $FFCCAA, -1)
    Case 10
      SetGadgetItemColor(0,  z, #PB_Gadget_BackColor,  $FFFFCC, -1) 
  EndSelect
  z + 1
EndIf 
EndMacro
;-------------------------------------------------------------------------------------------------- 

;==================================================================================================

Procedure LDTicks()
  For i = 1 To Looping       ;das Macro vom Code-Teil in den Speicher kopieren (duplizieren)
    CopyMemory(CodeA, CodeMem, CodeL)
    CodeMem + CodeL
  Next    
 
  PokeB(CodeMem, $C3)        ;zum Schluss Opcode fr Return setzen
  
  Ticks = 10000.0            ;irgend ein rel. hoher Wert   
  
  !mov esi,[v_DataMem] 
  MD_XMM_MEM128(MOVAPD)      ;definierte Werte setzen, um ungltige Werte in den XMM-Registern zu vermeiden (z.B. NaN)
  !mov ebp,123456789         ;z.B. fr Reg32-Reg32 definierter (Anfangs-)Wert fr EBP
 
  !FINIT
  !FLD1                      ;7-mal, nicht 8-mal! 
  !FLD1
  !FLD1
  !FLD1  
  !FLD1
  !FLD1
  !FLD1

  FlushInstructionCache_(GetCurrentProcess_(), #Null, #Null)    ;(bisherigen) Befehls-Cache lschen
  
  !cpuid                     ;fr Serialisierung (Pipe(s) leerfegen) 
 
  For i = 0 To 25
    !rdtsc                   ;Time-Stamp auslesen
    !mov dword[v_TimeA],eax  ;EAX = Low-DWord; diese Ticks drcken wir in den Skat
    !mov dword[v_TimeA+4],edx;EDX = High-DWord 
    !call [v_CodeMemUr]      ;Code im Speicher ausfhren
    !rdtsc
    !mov dword[v_TimeE],eax
    !mov dword[v_TimeE+4],edx
    TicksZ = (TimeE - TimeA) / (Looping * 8)     ;8 = Anzahl der Befehle pro Macro
    If TicksZ < Ticks
      Ticks = TicksZ         ;der kleinste Wert wird bentigt
    EndIf
  Next
EndProcedure