;- CPU-Latenz-Durchsatz-Messung, 32-Bit-Version, kein Unicode
;- "Helle" Klaus Helbing, 29.03.2009, PB 4.30, FAsm 1.67.38
;- Ohne MMX und 3DNow!, beide mittlerweile uninteressant
;- FPU ist noch unvollstndig
;- Latenz: Anzahl der Taktzyklen, um den Befehl komplett abzuarbeiten  
;- Durchsatz: Anzahl der Taktzyklen, bis derselbe Befehl erneut eingelesen werden kann
;             (nach Beginn des Einlesens des ersten Befehles)
;- Latenzmessung: Jeder nachfolgende (gleichartige) Befehl ist abhngig vom Ergebnis des vorhergehenden Befehls (wenn mglich)
;- Durchsatzmessung: Jeder nachfolgende (gleichartige) Befehl ist unabhngig vom Ergebnis des vorhergehenden Befehls (wenn mglich)
;- Die Abarbeitung der zu testenden Befehle erfolgt in speziell reserviertem Speicher
;- Ein Wert von z.B. 2.01 ist natrlich als 2.00 zu interpretieren! (auch 0.34 = 0.33 usw.)
;- Bei Speicherzugriffen wird es (wie zu erwarten) etwas unscharf, evtl. mehrere Tests machen
;- Bei einigen Befehlen macht eine Durchsatz-Messung keinen Sinn (=Latenz), wird dann auf 0.00 gesetzt
;- Instruktionen, die von Voraussetzungen wie z.B. Werte anderer Register abhngig sind, wurden
;-  hier trotzdem mit aufgenommen   

Global Bit0.l   = $1         ;fr SSE3
Global Bit9.l   = $200       ;fr SSSE3
Global Bit19.l  = $80000     ;fr SSE4.1
Global Bit20.l  = $100000    ;fr SSE4.2
Global Bit23.l  = $800000    ;fr POPCNT
Global Bit25.l  = $2000000   ;fr SSE
Global Bit26.l  = $4000000   ;fr SSE2
Global CPU.l

Global Mem.l = $100000       ;Speicher reservieren, hier 1MB, sollte reichlich bemessen sein
Global Looping.q = 1000
Global CodeMem.l
Global CodeMemUr.l
Global CodeA.l
Global CodeL.l
Global DataMem.l
Global StringAdresse.l
Global TimeA.q
Global TimeE.q
Global TicksL.d
Global TicksD.d
Global TicksZ.d
Global Ticks.d

XIncludeFile "LD.pbi" 

;-------- CPU-Namen ermitteln ---------
CPU$ = Space(48)             ;der String ist 48 Zeichen lang
StringAdresse = @CPU$
!mov eax,80000000h           ;Test, ob CPU aktuell genug ist um den String zu liefern
!cpuid
!cmp eax,80000004h
!jae @f                      ;alles o.K.
CPU$ = "CPU-Name nicht ermittelbar"
!jmp NoCPUName
!@@:
!mov esi,[v_StringAdresse]
!xor edi,edi
!@@:    
!mov eax,80000002h
!add eax,edi
!cpuid        
!mov [esi],eax
!mov [esi+4],ebx    
!mov [esi+8],ecx
!mov [esi+12],edx
!inc edi
!cmp edi,3
!je NoCPUName
!add esi,16
!jmp @b
!NoCPUName:
;--------------------------------------

;-------- Verfgbarkeiten berprfen
!mov eax,1h
!cpuid
!test edx,[v_Bit25]          ;SSE  
!jz @f
!mov [v_CPU],1
!@@:
!test edx,[v_Bit26]          ;SSE2  
!jz @f
!mov [v_CPU],2
!@@:
!test ecx,[v_Bit0]           ;SSE3
!jz @f
!mov [v_CPU],3  
!@@:
!test ecx,[v_Bit9]           ;SSSE3
!jz @f
!mov [v_CPU],4 
!@@:
!test ecx,[v_Bit19]          ;SSE4.1
!jz @f
!mov [v_CPU],5
!@@:
!test ecx,[v_Bit20]          ;SSE4.2
!jz @f
!mov [v_CPU],6
!@@:
!test ecx,[v_Bit23]          ;POPCNT
!jz @f
!mov [v_CPU],7
!@@:
;--------------------------------------

If OpenWindow(0, 0, 0, 400, 320, "CPU-Takte fr " + CPU$, #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  If CreateMenu(0, WindowID(0))
    MenuItem(1, "Speichern")
    MenuItem(2, "Speichern unter")
    MenuItem(3, "Drucken")
    MenuItem(4, "Beenden")
  EndIf  
    
  ListIconGadget(0, 10, 10, 380, 280, "Befehl", 235, #PB_ListIcon_GridLines | #LVS_NOSORTHEADER | #PB_ListIcon_FullRowSelect)
  AddGadgetColumn(0, 1, "Latenz", 60)
  AddGadgetColumn(0, 2, "Durchsatz", 65)
  TextGadget(1, 70,  13, 40, 14, " (x86) ", #PB_Text_Center)
  SetGadgetColor(1, #PB_Gadget_BackColor, $99FFFF)
  TextGadget(2, 130,  13, 40, 14, " (SSEx) ", #PB_Text_Center)
  SetGadgetColor(2, #PB_Gadget_BackColor, $FFCCAA)
  TextGadget(3, 190,  13, 40, 14, " (FPU) ", #PB_Text_Center)
  SetGadgetColor(3, #PB_Gadget_BackColor, $FFFFCC)

  hThread = GetCurrentThread_()
  SetThreadAffinityMask_(hThread, 1)   ;Thread nur von Core0 ausfhren lassen (wenn Multi-Core-CPU)
  SetThreadPriority_(hThread, #THREAD_PRIORITY_TIME_CRITICAL)

  CodeMem = VirtualAllocEx_(GetCurrentProcess_(), #Null, Mem, #MEM_COMMIT, #PAGE_EXECUTE_READWRITE)
  CodeMem + 16 - (CodeMem % 16)        ;um sicher Alignment16 zu erreichen
  DataMem = CodeMem
 
  If CodeMem
    !lea esi,[MemAli]                  ;data section umkopieren
    !mov [v_CodeA],esi
    CodeL = 496                        ;496=Lnge data section
    CopyMemory(CodeA, CodeMem, CodeL)
    CodeMem + CodeL

    DisableDebugger
    CodeMemUr = CodeMem                ;ab hier Code 

    I$ = "AAA" : Messung(ML_(AAA), MD_(AAA), 0, 0)    ;erstmal MD angeben
    I$ = "AAD" : Messung(ML_(AAD), MD_(AAD), 0, 0)
    I$ = "AAM" : Messung(ML_(AAM), MD_(AAM), 0, 0)
    I$ = "AAS" : Messung(ML_(AAS), MD_(AAS), 0, 0)
    I$ = "ADC REG32, REG32" : Messung(ML_REG32_REG32(ADC), MD_REG32_REG32(ADC), 1, 0)
    I$ = "ADC REG32, MEM32" : Messung(ML_REG32_MEM32(ADC), MD_REG32_MEM32(ADC), 1, 0)
    I$ = "ADC MEM32, REG32" : Messung(ML_MEM32_REG32(ADC), MD_MEM32_REG32(ADC), 1, 0)
    I$ = "ADC REG32, Const32" : Messung(ML_REG32_IMMFEST(ADC, 12345678), MD_REG32_IMMFEST(ADC, 12345678), 1, 0)
    I$ = "ADC MEM32, Const32" : Messung(ML_MEM32_IMMFEST(ADC, 12345678), MD_MEM32_IMMFEST(ADC, 12345678), 1, 0) 
    I$ = "ADD REG32, REG32" : Messung(ML_REG32_REG32(ADD), MD_REG32_REG32(ADD), 1, 0)
    I$ = "ADD REG32, MEM32" : Messung(ML_REG32_MEM32(ADD), MD_REG32_MEM32(ADD), 1, 0)
    I$ = "ADD MEM32, REG32" : Messung(ML_MEM32_REG32(ADD), MD_MEM32_REG32(ADD), 1, 0)
    I$ = "ADD REG32, Const32" : Messung(ML_REG32_IMMFEST(ADD, 12345678), MD_REG32_IMMFEST(ADD, 12345678), 1, 0)
    I$ = "ADD MEM32, Const32" : Messung(ML_MEM32_IMMFEST(ADD, 12345678), MD_MEM32_IMMFEST(ADD, 12345678), 1, 0)  
    I$ = "AND REG32, REG32" : Messung(ML_REG32_REG32(And), MD_REG32_REG32(And), 1, 0)
    I$ = "AND REG32, MEM32" : Messung(ML_REG32_MEM32(And), MD_REG32_MEM32(And), 1, 0)
    I$ = "AND MEM32, REG32" : Messung(ML_MEM32_REG32(And), MD_MEM32_REG32(And), 1, 0)
    I$ = "AND REG32, Const32" : Messung(ML_REG32_IMMFEST(And, 12345678), MD_REG32_IMMFEST(And, 12345678), 1, 0)
    I$ = "AND MEM32, Const32" : Messung(ML_MEM32_IMMFEST(And, 12345678), MD_MEM32_IMMFEST(And, 12345678), 1, 0)   
    I$ = "BSF REG32, REG32" : Messung(ML_REG32_REG32(BSF), MD_REG32_REG32(BSF), 1, 0)
    I$ = "BSF REG32, MEM32" : Messung(ML_REG32_MEM32(BSF), MD_REG32_MEM32(BSF), 1, 0)
    I$ = "BSR REG32, REG32" : Messung(ML_REG32_REG32(BSR), MD_REG32_REG32(BSR), 1, 0)
    I$ = "BSR REG32, MEM32" : Messung(ML_REG32_MEM32(BSR), MD_REG32_MEM32(BSR), 1, 0) 
    I$ = "BSWAP REG32" : Messung(ML_REG32(BSWAP), MD_REG32(BSWAP), 1, 0)
    I$ = "BT REG32, REG32" : Messung(ML_REG32_REG32(BT), MD_REG32_REG32(BT), 1, 0)
    I$ = "BT REG32, Const8" : Messung(ML_REG32_IMMFEST(BT, 5), MD_REG32_IMMFEST(BT, 5), 1, 0)
    I$ = "BT MEM32, Const8" : Messung(ML_MEM32_IMMFEST(BT, 5), MD_MEM32_IMMFEST(BT, 5), 1, 0)
    I$ = "BTC REG32, REG32" : Messung(ML_REG32_REG32(BTC), MD_REG32_REG32(BTC), 1, 0)
    I$ = "BTC REG32, Const8" : Messung(ML_REG32_IMMFEST(BTC, 5), MD_REG32_IMMFEST(BTC, 5), 1, 0)
    I$ = "BTC MEM32, Const8" : Messung(ML_MEM32_IMMFEST(BTC, 5), MD_MEM32_IMMFEST(BTC, 5), 1, 0)
    I$ = "BTR REG32, REG32" : Messung(ML_REG32_REG32(BTR), MD_REG32_REG32(BTR), 1, 0)
    I$ = "BTR REG32, Const8" : Messung(ML_REG32_IMMFEST(BTR, 5), MD_REG32_IMMFEST(BTR, 5), 1, 0)
    I$ = "BTR MEM32, Const8" : Messung(ML_MEM32_IMMFEST(BTR, 5), MD_MEM32_IMMFEST(BTR, 5), 1, 0)
    I$ = "BTS REG32, REG32" : Messung(ML_REG32_REG32(BTS), MD_REG32_REG32(BTS), 1, 0)
    I$ = "BTS REG32, Const8" : Messung(ML_REG32_IMMFEST(BTS, 5), MD_REG32_IMMFEST(BTS, 5), 1, 0)
    I$ = "BTS MEM32, Const8" : Messung(ML_MEM32_IMMFEST(BTS, 5), MD_MEM32_IMMFEST(BTS, 5), 1, 0)
    I$ = "CDQ" : Messung(ML_(CDQ), MD_(CDQ), 0, 0)
    I$ = "CLC" : Messung(ML_(CLC), MD_(CLC), 0, 0) 
    I$ = "CLD" : Messung(ML_(CLD), MD_(CLD), 0, 0) 
    I$ = "CMC" : Messung(ML_(CMC), MD_(CMC), 0, 0) 
    I$ = "CMOVA REG32, REG32" : Messung(ML_REG32_REG32(CMOVA), MD_REG32_REG32(CMOVA), 1, 0)
    I$ = "CMOVA REG32, MEM32" : Messung(ML_REG32_MEM32(CMOVA), MD_REG32_MEM32(CMOVA), 1, 0) 
    I$ = "CMOVE REG32, REG32" : Messung(ML_REG32_REG32(CMOVE), MD_REG32_REG32(CMOVE), 1, 0)
    I$ = "CMOVE REG32, MEM32" : Messung(ML_REG32_MEM32(CMOVE), MD_REG32_MEM32(CMOVE), 1, 0)  
    I$ = "CMOVNE REG32, REG32" : Messung(ML_REG32_REG32(CMOVNE), MD_REG32_REG32(CMOVNE), 1, 0)
    I$ = "CMOVNE REG32, MEM32" : Messung(ML_REG32_MEM32(CMOVNE), MD_REG32_MEM32(CMOVNE), 1, 0)  
    I$ = "CMP REG32, REG32" : Messung(ML_REG32_REG32(CMP), MD_REG32_REG32(CMP), 1, 0)
    I$ = "CMP REG32, MEM32" : Messung(ML_REG32_MEM32(CMP), MD_REG32_MEM32(CMP), 1, 0)
    I$ = "CMP MEM32, REG32" : Messung(ML_MEM32_REG32(CMP), MD_MEM32_REG32(CMP), 1, 0)
    I$ = "CMP REG32, Const32" : Messung(ML_REG32_IMMFEST(CMP, 12345678), MD_REG32_IMMFEST(CMP, 12345678), 1, 0)
    I$ = "CMP MEM32, Const32" : Messung(ML_MEM32_IMMFEST(CMP, 12345678), MD_MEM32_IMMFEST(CMP, 12345678), 1, 0)   
    I$ = "CMPXCHG REG32, REG32" : Messung(ML_REG32_REG32(CMPXCHG), MD_REG32_REG32(CMPXCHG), 1, 0)
    I$ = "CMPXCHG MEM32, REG32" : Messung(ML_MEM32_REG32(CMPXCHG), MD_MEM32_REG32(CMPXCHG), 1, 0)
    I$ = "CPUID" : Messung(ML_(CPUID), MD_(CPUID), 0, 0)
    I$ = "DAA" : Messung(ML_(DAA), MD_(DAA), 0, 0)
    I$ = "DAS" : Messung(ML_(DAS), MD_(DAS), 0, 0)
    I$ = "DEC REG32" : Messung(ML_REG32(DEC), MD_REG32(DEC), 1, 0)
    I$ = "DEC MEM32" : Messung(ML_MEM32(DEC), MD_MEM32(DEC), 1, 0)
    ;I$ = "DIV REG32" : Messung(ML_REG32(DIV), MD_REG32(DIV), 1, 0)   ;evtl. mal eigene Routine
    ;I$ = "DIV MEM32" : Messung(ML_MEM32(DIV), MD_MEM32(DIV), 1, 0)
    ;I$ = "IDIV REG32" : Messung(ML_REG32(IDIV), MD_REG32(IDIV), 1, 0)
    ;I$ = "IDIV MEM32" : Messung(ML_MEM32(IDIV), MD_MEM32(IDIV), 1, 0)
    I$ = "IMUL REG32" : Messung(ML_REG32(IMUL), MD_REG32(IMUL), 1, 0)
    I$ = "IMUL MEM32" : Messung(ML_MEM32(IMUL), MD_MEM32(IMUL), 1, 0)
    I$ = "IMUL REG32, REG32" : Messung(ML_REG32_REG32(IMUL), MD_REG32_REG32(IMUL), 1, 0)
    I$ = "IMUL REG32, MEM32" : Messung(ML_REG32_MEM32(IMUL), MD_REG32_MEM32(IMUL), 1, 0)
    I$ = "IMUL REG32, Const8" : Messung(ML_REG32_IMMFEST(IMUL, 123), MD_REG32_IMMFEST(IMUL, 123), 1, 0)
    I$ = "INC REG32" : Messung(ML_REG32(INC), MD_REG32(INC), 1, 0)
    I$ = "INC MEM32" : Messung(ML_MEM32(INC), MD_MEM32(INC), 1, 0)
    ;Sprnge aller Art, mal sehen
    I$ = "LAHF" : Messung(ML_(LAHF), MD_(LAHF), 0, 0)    
    I$ = "MOV REG32, REG32" : Messung(ML_REG32_REG32(MOV), MD_REG32_REG32(MOV), 1, 0)
    I$ = "MOV REG32, MEM32" : Messung(ML_REG32_MEM32(MOV), MD_REG32_MEM32(MOV), 1, 0)
    I$ = "MOV MEM32, REG32" : Messung(ML_MEM32_REG32(MOV), MD_MEM32_REG32(MOV), 1, 0)
    I$ = "MOV REG32, Const32" : Messung(ML_REG32_IMMFEST(MOV, 12345678), MD_REG32_IMMFEST(MOV, 12345678), 1, 0)
    I$ = "MOV MEM32, Const32" : Messung(ML_MEM32_IMMFEST(MOV, 12345678), MD_MEM32_IMMFEST(MOV, 12345678), 1, 0) 
    I$ = "MOVSX REG32, REG8" : Messung(ML_REG32_REG8(MOVSX), MD_REG32_REG8(MOVSX), 1, 0)
    I$ = "MOVZX REG32, REG8" : Messung(ML_REG32_REG8(MOVZX), MD_REG32_REG8(MOVZX), 1, 0)
    I$ = "MUL REG32" : Messung(ML_REG32(MUL), MD_REG32(MUL), 1, 0)
    I$ = "MUL MEM32" : Messung(ML_MEM32(MUL), MD_MEM32(MUL), 1, 0)
    I$ = "NEG REG32" : Messung(ML_REG32(NEG), MD_REG32(NEG), 1, 0)
    I$ = "NEG MEM32" : Messung(ML_MEM32(NEG), MD_MEM32(NEG), 1, 0)
    I$ = "NOP" : Messung(ML_(NOP), MD_(NOP), 0, 0)
    I$ = "NOT REG32" : Messung(ML_REG32(Not), MD_REG32(Not), 1, 0)
    I$ = "NOT MEM32" : Messung(ML_MEM32(Not), MD_MEM32(Not), 1, 0)
    I$ = "OR REG32, REG32" : Messung(ML_REG32_REG32(Or), MD_REG32_REG32(Or), 1, 0)
    I$ = "OR REG32, MEM32" : Messung(ML_REG32_MEM32(Or), MD_REG32_MEM32(Or), 1, 0)
    I$ = "OR MEM32, REG32" : Messung(ML_MEM32_REG32(Or), MD_MEM32_REG32(Or), 1, 0)
    I$ = "OR REG32, Const32" : Messung(ML_REG32_IMMFEST(Or, 12345678), MD_REG32_IMMFEST(Or, 12345678), 1, 0)
    I$ = "OR MEM32, Const32" : Messung(ML_MEM32_IMMFEST(Or, 12345678), MD_MEM32_IMMFEST(Or, 12345678), 1, 0) 
    ;evtl. mal PUSH/POP (als Kombination ?)
    I$ = "RCL REG32, 1" : Messung(ML_REG32_IMMFEST(RCL, 1), MD_REG32_IMMFEST(RCL, 1), 1, 0)
    I$ = "RCL MEM32, 1" : Messung(ML_MEM32_IMMFEST(RCL, 1), MD_MEM32_IMMFEST(RCL, 1), 1, 0)    
    I$ = "RCL REG32, CL" : Messung(ML_REG32_REG8(RCL), MD_REG32_REG8(RCL), 1, 0)
    I$ = "RCL MEM32, CL" : Messung(ML_MEM32_REG8(RCL), MD_MEM32_REG8(RCL), 1, 0)   
    I$ = "RCL REG32, Const8" : Messung(ML_REG32_IMMVAR(RCL), MD_REG32_IMMVAR(RCL), 1, 0)
    I$ = "RCL MEM32, Const8" : Messung(ML_MEM32_IMMVAR(RCL), MD_MEM32_IMMVAR(RCL), 1, 0)
    I$ = "RCR REG32, 1" : Messung(ML_REG32_IMMFEST(RCR, 1), MD_REG32_IMMFEST(RCR, 1), 1, 0)
    I$ = "RCR MEM32, 1" : Messung(ML_MEM32_IMMFEST(RCR, 1), MD_MEM32_IMMFEST(RCR, 1), 1, 0)    
    I$ = "RCR REG32, CL" : Messung(ML_REG32_REG8(RCR), MD_REG32_REG8(RCR), 1, 0)
    I$ = "RCR MEM32, CL" : Messung(ML_MEM32_REG8(RCR), MD_MEM32_REG8(RCR), 1, 0)   
    I$ = "RCR REG32, Const8" : Messung(ML_REG32_IMMVAR(RCR), MD_REG32_IMMVAR(RCR), 1, 0)
    I$ = "RCR MEM32, Const8" : Messung(ML_MEM32_IMMVAR(RCR), MD_MEM32_IMMVAR(RCR), 1, 0)
    I$ = "RDTSC" : Messung(ML_(RDTSC), MD_(RDTSC), 0, 0)
    I$ = "ROL REG32, 1" : Messung(ML_REG32_IMMFEST(ROL, 1), MD_REG32_IMMFEST(ROL, 1), 1, 0)
    I$ = "ROL MEM32, 1" : Messung(ML_MEM32_IMMFEST(ROL, 1), MD_MEM32_IMMFEST(ROL, 1), 1, 0)    
    I$ = "ROL REG32, CL" : Messung(ML_REG32_REG8(ROL), MD_REG32_REG8(ROL), 1, 0)
    I$ = "ROL MEM32, CL" : Messung(ML_MEM32_REG8(ROL), MD_MEM32_REG8(ROL), 1, 0)   
    I$ = "ROL REG32, Const8" : Messung(ML_REG32_IMMVAR(ROL), MD_REG32_IMMVAR(ROL), 1, 0)
    I$ = "ROL MEM32, Const8" : Messung(ML_MEM32_IMMVAR(ROL), MD_MEM32_IMMVAR(ROL), 1, 0)
    I$ = "ROR REG32, 1" : Messung(ML_REG32_IMMFEST(ROR, 1), MD_REG32_IMMFEST(ROR, 1), 1, 0)
    I$ = "ROR MEM32, 1" : Messung(ML_MEM32_IMMFEST(ROR, 1), MD_MEM32_IMMFEST(ROR, 1), 1, 0)    
    I$ = "ROR REG32, CL" : Messung(ML_REG32_REG8(ROR), MD_REG32_REG8(ROR), 1, 0)
    I$ = "ROR MEM32, CL" : Messung(ML_MEM32_REG8(ROR), MD_MEM32_REG8(ROR), 1, 0)   
    I$ = "ROR REG32, Const8" : Messung(ML_REG32_IMMVAR(ROR), MD_REG32_IMMVAR(ROR), 1, 0)
    I$ = "ROR MEM32, Const8" : Messung(ML_MEM32_IMMVAR(ROR), MD_MEM32_IMMVAR(ROR), 1, 0)
    I$ = "SAHF" : Messung(ML_(SAHF), MD_(SAHF), 0, 0)
    I$ = "SAL REG32, 1  (identisch mit SHL)" : Messung(ML_REG32_IMMFEST(SAL, 1), MD_REG32_IMMFEST(SAL, 1), 1, 0)
    I$ = "SAL MEM32, 1  (identisch mit SHL)" : Messung(ML_MEM32_IMMFEST(SAL, 1), MD_MEM32_IMMFEST(SAL, 1), 1, 0)    
    I$ = "SAL REG32, CL  (identisch mit SHL)" : Messung(ML_REG32_REG8(SAL), MD_REG32_REG8(SAL), 1, 0)
    I$ = "SAL MEM32, CL  (identisch mit SHL)" : Messung(ML_MEM32_REG8(SAL), MD_MEM32_REG8(SAL), 1, 0)   
    I$ = "SAL REG32, Const8  (identisch mit SHL)" : Messung(ML_REG32_IMMVAR(SAL), MD_REG32_IMMVAR(SAL), 1, 0)
    I$ = "SAL MEM32, Const8  (identisch mit SHL)" : Messung(ML_MEM32_IMMVAR(SAL), MD_MEM32_IMMVAR(SAL), 1, 0)
    I$ = "SAR REG32, 1" : Messung(ML_REG32_IMMFEST(SAR, 1), MD_REG32_IMMFEST(SAR, 1), 1, 0)
    I$ = "SAR MEM32, 1" : Messung(ML_MEM32_IMMFEST(SAR, 1), MD_MEM32_IMMFEST(SAR, 1), 1, 0)    
    I$ = "SAR REG32, CL" : Messung(ML_REG32_REG8(SAR), MD_REG32_REG8(SAR), 1, 0)
    I$ = "SAR MEM32, CL" : Messung(ML_MEM32_REG8(SAR), MD_MEM32_REG8(SAR), 1, 0)   
    I$ = "SAR REG32, Const8" : Messung(ML_REG32_IMMVAR(SAR), MD_REG32_IMMVAR(SAR), 1, 0)
    I$ = "SAR MEM32, Const8" : Messung(ML_MEM32_IMMVAR(SAR), MD_MEM32_IMMVAR(SAR), 1, 0)
    I$ = "SBB REG32, REG32" : Messung(ML_REG32_REG32(SBB), MD_REG32_REG32(SBB), 1, 0)
    I$ = "SBB REG32, MEM32" : Messung(ML_REG32_MEM32(SBB), MD_REG32_MEM32(SBB), 1, 0)
    I$ = "SBB MEM32, REG32" : Messung(ML_MEM32_REG32(SBB), MD_MEM32_REG32(SBB), 1, 0)
    I$ = "SBB REG32, Const32" : Messung(ML_REG32_IMMFEST(SBB, 12345678), MD_REG32_IMMFEST(SBB, 12345678), 1, 0)
    I$ = "SBB MEM32, Const32" : Messung(ML_MEM32_IMMFEST(SBB, 12345678), MD_MEM32_IMMFEST(SBB, 12345678), 1, 0) 
    I$ = "SHL REG32, 1  (identisch mit SAL)" : Messung(ML_REG32_IMMFEST(SHL, 1), MD_REG32_IMMFEST(SHL, 1), 1, 0)
    I$ = "SHL MEM32, 1  (identisch mit SAL)" : Messung(ML_MEM32_IMMFEST(SHL, 1), MD_MEM32_IMMFEST(SHL, 1), 1, 0)    
    I$ = "SHL REG32, CL  (identisch mit SAL)" : Messung(ML_REG32_REG8(SHL), MD_REG32_REG8(SHL), 1, 0)
    I$ = "SHL MEM32, CL  (identisch mit SAL)" : Messung(ML_MEM32_REG8(SHL), MD_MEM32_REG8(SHL), 1, 0)   
    I$ = "SHL REG32, Const8  (identisch mit SAL)" : Messung(ML_REG32_IMMVAR(SHL), MD_REG32_IMMVAR(SHL), 1, 0)
    I$ = "SHL MEM32, Const8  (identisch mit SAL)" : Messung(ML_MEM32_IMMVAR(SHL), MD_MEM32_IMMVAR(SHL), 1, 0)
    I$ = "SHR REG32, 1" : Messung(ML_REG32_IMMFEST(SHR, 1), MD_REG32_IMMFEST(SHR, 1), 1, 0)
    I$ = "SHR MEM32, 1" : Messung(ML_MEM32_IMMFEST(SHR, 1), MD_MEM32_IMMFEST(SHR, 1), 1, 0)    
    I$ = "SHR REG32, CL" : Messung(ML_REG32_REG8(SHR), MD_REG32_REG8(SHR), 1, 0)
    I$ = "SHR MEM32, CL" : Messung(ML_MEM32_REG8(SHR), MD_MEM32_REG8(SHR), 1, 0)   
    I$ = "SHR REG32, Const8" : Messung(ML_REG32_IMMVAR(SHR), MD_REG32_IMMVAR(SHR), 1, 0)
    I$ = "SHR MEM32, Const8" : Messung(ML_MEM32_IMMVAR(SHR), MD_MEM32_IMMVAR(SHR), 1, 0)
    I$ = "STC" : Messung(ML_(STC), MD_(STC), 0, 0) 
    I$ = "SUB REG32, REG32" : Messung(ML_REG32_REG32(SUB), MD_REG32_REG32(SUB), 1, 0)
    I$ = "SUB REG32, MEM32" : Messung(ML_REG32_MEM32(SUB), MD_REG32_MEM32(SUB), 1, 0)
    I$ = "SUB MEM32, REG32" : Messung(ML_MEM32_REG32(SUB), MD_MEM32_REG32(SUB), 1, 0)
    I$ = "SUB REG32, Const32" : Messung(ML_REG32_IMMFEST(SUB, 12345678), MD_REG32_IMMFEST(SUB, 12345678), 1, 0)
    I$ = "SUB MEM32, Const32" : Messung(ML_MEM32_IMMFEST(SUB, 12345678), MD_MEM32_IMMFEST(SUB, 12345678), 1, 0)  
    I$ = "TEST REG32, REG32" : Messung(ML_REG32_REG32(TEST), MD_REG32_REG32(TEST), 1, 0)
    I$ = "TEST REG32, MEM32" : Messung(ML_REG32_MEM32(TEST), MD_REG32_MEM32(TEST), 1, 0)
    I$ = "TEST MEM32, REG32" : Messung(ML_MEM32_REG32(TEST), MD_MEM32_REG32(TEST), 1, 0)
    I$ = "TEST REG32, Const32" : Messung(ML_REG32_IMMFEST(TEST, 12345678), MD_REG32_IMMFEST(TEST, 12345678), 1, 0)
    I$ = "TEST MEM32, Const32" : Messung(ML_MEM32_IMMFEST(TEST, 12345678), MD_MEM32_IMMFEST(TEST, 12345678), 1, 0)   
    I$ = "XADD REG32, REG32" : Messung(ML_REG32_REG32(XADD), MD_REG32_REG32(XADD), 1, 0)
    I$ = "XADD MEM32, REG32" : Messung(ML_MEM32_REG32(XADD), MD_MEM32_REG32(XADD), 1, 0)
    I$ = "XCHG REG32, REG32" : Messung(ML_REG32_REG32(XCHG), MD_REG32_REG32(XCHG), 1, 0)
    I$ = "XCHG REG32, MEM32" : Messung(ML_REG32_MEM32(XCHG), MD_REG32_MEM32(XCHG), 1, 0)    
    I$ = "XCHG MEM32, REG32" : Messung(ML_MEM32_REG32(XCHG), MD_MEM32_REG32(XCHG), 1, 0)
    I$ = "XOR REG32, REG32" : Messung(ML_REG32_REG32(XOr), MD_REG32_REG32(XOr), 1, 0)
    I$ = "XOR REG32, MEM32" : Messung(ML_REG32_MEM32(XOr), MD_REG32_MEM32(XOr), 1, 0)
    I$ = "XOR MEM32, REG32" : Messung(ML_MEM32_REG32(XOr), MD_MEM32_REG32(XOr), 1, 0)
    I$ = "XOR REG32, Const32" : Messung(ML_REG32_IMMFEST(XOr, 12345678), MD_REG32_IMMFEST(XOr, 12345678), 1, 0)
    I$ = "XOR MEM32, Const32" : Messung(ML_MEM32_IMMFEST(XOr, 12345678), MD_MEM32_IMMFEST(XOr, 12345678), 1, 0) 
;--------------------------------------------------------------------------------------------------
    I$ = "ADDPD XMM, XMM" : Messung(ML_XMM_XMM(ADDPD), MD_XMM_XMM(ADDPD), 1, 2)
    I$ = "ADDPD XMM, MEM128" : Messung(ML_XMM_MEM128(ADDPD), MD_XMM_MEM128(ADDPD), 1, 2)   
    I$ = "ADDPS XMM, XMM" : Messung(ML_XMM_XMM(ADDPS), MD_XMM_XMM(ADDPS), 1, 1)
    I$ = "ADDPS XMM, MEM128" : Messung(ML_XMM_MEM128(ADDPS), MD_XMM_MEM128(ADDPS), 1, 1)   
    I$ = "ADDSD XMM, XMM" : Messung(ML_XMM_XMM(ADDSD), MD_XMM_XMM(ADDSD), 1, 2)  
    I$ = "ADDSD XMM, MEM64" : Messung(ML_XMM_MEM64(ADDSD), MD_XMM_MEM64(ADDSD), 1, 2)     
    I$ = "ADDSS XMM, XMM" : Messung(ML_XMM_XMM(ADDSS), MD_XMM_XMM(ADDSS), 1, 1)  
    I$ = "ADDSS XMM, MEM32" : Messung(ML_XMM_MEM32(ADDSS), MD_XMM_MEM32(ADDSS), 1, 1)    
    I$ = "ADDSUBPD XMM, XMM" : Messung(ML_XMM_XMM(ADDSUBPD), MD_XMM_XMM(ADDSUBPD), 1, 3)
    I$ = "ADDSUBPD XMM, MEM128" : Messung(ML_XMM_MEM128(ADDSUBPD), MD_XMM_MEM128(ADDSUBPD), 1, 3)     
    I$ = "ADDSUBPS XMM, XMM" : Messung(ML_XMM_XMM(ADDSUBPS), MD_XMM_XMM(ADDSUBPS), 1, 3)
    I$ = "ADDSUBPS XMM, MEM128" : Messung(ML_XMM_MEM128(ADDSUBPS), MD_XMM_MEM128(ADDSUBPS), 1, 3)   
    I$ = "ANDPD XMM, XMM" : Messung(ML_XMM_XMM(ANDPD), MD_XMM_XMM(ANDPD), 1, 2)
    I$ = "ANDPD XMM, MEM128" : Messung(ML_XMM_MEM128(ANDPD), MD_XMM_MEM128(ANDPD), 1, 2)     
    I$ = "ANDPS XMM, XMM" : Messung(ML_XMM_XMM(ANDPS), MD_XMM_XMM(ANDPS), 1, 1)
    I$ = "ANDPS XMM, MEM128" : Messung(ML_XMM_MEM128(ANDPS), MD_XMM_MEM128(ANDPS), 1, 1)    
    I$ = "ANDNPD XMM, XMM" : Messung(ML_XMM_XMM(ANDNPD), MD_XMM_XMM(ANDNPD), 1, 2)
    I$ = "ANDNPD XMM, MEM128" : Messung(ML_XMM_MEM128(ANDNPD), MD_XMM_MEM128(ANDNPD), 1, 2)     
    I$ = "ANDNPS XMM, XMM" : Messung(ML_XMM_XMM(ANDNPS), MD_XMM_XMM(ANDNPS), 1, 1)
    I$ = "ANDNPS XMM, MEM128" : Messung(ML_XMM_MEM128(ANDNPS), MD_XMM_MEM128(ANDNPS), 1, 1) 
    I$ = "BLENDPD XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(BLENDPD, 1), MD_XMM_XMM_IMMFEST(BLENDPD, 1), 1, 5)
    I$ = "BLENDPD XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(BLENDPD, 1), MD_XMM_MEM128_IMMFEST(BLENDPD, 1), 1, 5)     
    I$ = "BLENDPS XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(BLENDPS, 1), MD_XMM_XMM_IMMFEST(BLENDPS, 1), 1, 5)
    I$ = "BLENDPS XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(BLENDPS, 1), MD_XMM_MEM128_IMMFEST(BLENDPS, 1), 1, 5)  
    I$ = "BLENDVPD XMM, XMM, XMM0" : Messung(ML_XMM_XMM_XMM0(BLENDVPD), MD_XMM_XMM_XMM0(BLENDVPD), 1, 5)
    I$ = "BLENDVPD XMM, MEM128, XMM0" : Messung(ML_XMM_MEM128_XMM0(BLENDVPD), MD_XMM_MEM128_XMM0(BLENDVPD), 1, 5)     
    I$ = "BLENDVPS XMM, XMM, XMM0" : Messung(ML_XMM_XMM_XMM0(BLENDVPS), MD_XMM_XMM_XMM0(BLENDVPS), 1, 5)
    I$ = "BLENDVPS XMM, MEM128, XMM0" : Messung(ML_XMM_MEM128_XMM0(BLENDVPS), MD_XMM_MEM128_XMM0(BLENDVPS), 1, 5)   
    I$ = "CMPPD XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(CMPPD, 3), MD_XMM_XMM_IMMFEST(CMPPD, 3), 1, 2)
    I$ = "CMPPD XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(CMPPD, 3), MD_XMM_MEM128_IMMFEST(CMPPD, 3), 1, 2)  
    I$ = "CMPPS XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(CMPPS, 3), MD_XMM_XMM_IMMFEST(CMPPS, 3), 1, 1)
    I$ = "CMPPS XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(CMPPS, 3), MD_XMM_MEM128_IMMFEST(CMPPS, 3), 1, 1)   
    I$ = "CMPSD XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(CMPSD, 3), MD_XMM_XMM_IMMFEST(CMPSD, 3), 1, 2)
    I$ = "CMPSD XMM, MEM64, Const8" : Messung(ML_XMM_MEM64_IMMFEST(CMPSD, 3), MD_XMM_MEM64_IMMFEST(CMPSD, 3), 1, 2)  
    I$ = "CMPSS XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(CMPSS, 3), MD_XMM_XMM_IMMFEST(CMPSS, 3), 1, 1)
    I$ = "CMPSS XMM, MEM32, Const8" : Messung(ML_XMM_MEM32_IMMFEST(CMPSS, 3), MD_XMM_MEM32_IMMFEST(CMPSS, 3), 1, 1)   
    I$ = "COMISD XMM, XMM" : Messung(ML_XMM_XMM(COMISD), MD_XMM_XMM(COMISD), 1, 2)  
    I$ = "COMISD XMM, MEM64" : Messung(ML_XMM_MEM64(COMISD), MD_XMM_MEM64(COMISD), 1, 2)
    I$ = "COMISS XMM, XMM" : Messung(ML_XMM_XMM(COMISS), MD_XMM_XMM(COMISS), 1, 1)  
    I$ = "COMISS XMM, MEM32" : Messung(ML_XMM_MEM32(COMISS), MD_XMM_MEM32(COMISS), 1, 1)
    I$ = "CVTDQ2PD XMM, XMM" : Messung(ML_XMM_XMM(CVTDQ2PD), MD_XMM_XMM(CVTDQ2PD), 1, 2)  
    I$ = "CVTDQ2PD XMM, MEM64" : Messung(ML_XMM_MEM128(CVTDQ2PD), MD_XMM_MEM128(CVTDQ2PD), 1, 2)  ;muss MEM128 sein!
    I$ = "CVTDQ2PS XMM, XMM" : Messung(ML_XMM_XMM(CVTDQ2PS), MD_XMM_XMM(CVTDQ2PS), 1, 2)  
    I$ = "CVTDQ2PS XMM, MEM128" : Messung(ML_XMM_MEM128(CVTDQ2PS), MD_XMM_MEM128(CVTDQ2PS), 1, 2)
    I$ = "CVTPD2DQ XMM, XMM" : Messung(ML_XMM_XMM(CVTPD2DQ), MD_XMM_XMM(CVTPD2DQ), 1, 2)  
    I$ = "CVTPD2DQ XMM, MEM128" : Messung(ML_XMM_MEM128(CVTPD2DQ), MD_XMM_MEM128(CVTPD2DQ), 1, 2)  
    I$ = "CVTPD2PS XMM, XMM" : Messung(ML_XMM_XMM(CVTPD2PS), MD_XMM_XMM(CVTPD2PS), 1, 2)  
    I$ = "CVTPD2PS XMM, MEM128" : Messung(ML_XMM_MEM128(CVTPD2PS), MD_XMM_MEM128(CVTPD2PS), 1, 2)    
    I$ = "CVTPI2PD XMM, MEM64" : Messung(ML_XMM_MEM64(CVTPI2PD), MD_XMM_MEM64(CVTPI2PD), 1, 2)  
    I$ = "CVTPI2PS XMM, MEM64" : Messung(ML_XMM_MEM64(CVTPI2PS), MD_XMM_MEM64(CVTPI2PS), 1, 1)  
    I$ = "CVTPS2DQ XMM, XMM" : Messung(ML_XMM_XMM(CVTPS2DQ), MD_XMM_XMM(CVTPS2DQ), 1, 2)  
    I$ = "CVTPS2DQ XMM, MEM128" : Messung(ML_XMM_MEM128(CVTPS2DQ), MD_XMM_MEM128(CVTPS2DQ), 1, 2)  
    I$ = "CVTPS2PD XMM, XMM" : Messung(ML_XMM_XMM(CVTPS2PD), MD_XMM_XMM(CVTPS2PD), 1, 2)  
    I$ = "CVTPS2PD XMM, MEM64" : Messung(ML_XMM_MEM64(CVTPS2PD), MD_XMM_MEM64(CVTPS2PD), 1, 2)  
    I$ = "CVTSD2SI REG32, XMM" : Messung(ML_REG32_XMM(CVTSD2SI), MD_REG32_XMM(CVTSD2SI), 1, 2)   
    I$ = "CVTSD2SS XMM, XMM" : Messung(ML_XMM_XMM(CVTSD2SS), MD_XMM_XMM(CVTSD2SS), 1, 2)  
    I$ = "CVTSD2SS XMM, MEM64" : Messung(ML_XMM_MEM64(CVTSD2SS), MD_XMM_MEM64(CVTSD2SS), 1, 2)  
    I$ = "CVTSI2SD XMM, REG32" : Messung(ML_XMM_REG32(CVTSI2SD), MD_XMM_REG32(CVTSI2SD), 1, 2)  
    I$ = "CVTSI2SD XMM, MEM32" : Messung(ML_XMM_MEM32(CVTSI2SD), MD_XMM_MEM32(CVTSI2SD), 1, 2)  
    I$ = "CVTSI2SS XMM, REG32" : Messung(ML_XMM_REG32(CVTSI2SS), MD_XMM_REG32(CVTSI2SS), 1, 1)  
    I$ = "CVTSI2SS XMM, MEM32" : Messung(ML_XMM_MEM32(CVTSI2SS), MD_XMM_MEM32(CVTSI2SS), 1, 1)
    I$ = "CVTSS2SD XMM, XMM" : Messung(ML_XMM_XMM(CVTSS2SD), MD_XMM_XMM(CVTSS2SD), 1, 2)  
    I$ = "CVTSS2SD XMM, MEM32" : Messung(ML_XMM_MEM32(CVTSS2SD), MD_XMM_MEM32(CVTSS2SD), 1, 2)
    I$ = "CVTSS2SI REG32, XMM" : Messung(ML_REG32_XMM(CVTSS2SI), MD_REG32_XMM(CVTSS2SI), 1, 1) 
    I$ = "CVTTPD2DQ XMM, XMM" : Messung(ML_XMM_XMM(CVTTPD2DQ), MD_XMM_XMM(CVTTPD2DQ), 1, 2)  
    I$ = "CVTTPD2DQ XMM, MEM128" : Messung(ML_XMM_MEM128(CVTTPD2DQ), MD_XMM_MEM128(CVTTPD2DQ), 1, 2) 
    I$ = "CVTTPS2DQ XMM, XMM" : Messung(ML_XMM_XMM(CVTTPS2DQ), MD_XMM_XMM(CVTTPS2DQ), 1, 2)  
    I$ = "CVTTPS2DQ XMM, MEM128" : Messung(ML_XMM_MEM128(CVTTPS2DQ), MD_XMM_MEM128(CVTTPS2DQ), 1, 2) 
    I$ = "CVTTSD2SI REG32, XMM" : Messung(ML_REG32_XMM(CVTTSD2SI), MD_REG32_XMM(CVTTSD2SI), 1, 2) 
    I$ = "CVTTSS2SI REG32, XMM" : Messung(ML_REG32_XMM(CVTSS2SI), MD_REG32_XMM(CVTSS2SI), 1, 1)  
    I$ = "DIVPD XMM, XMM" : Messung(ML_XMM_XMM(DIVPD), MD_XMM_XMM(DIVPD), 1, 2)
    I$ = "DIVPD XMM, MEM128" : Messung(ML_XMM_MEM128(DIVPD), MD_XMM_MEM128(DIVPD), 1, 2)   
    I$ = "DIVPS XMM, XMM" : Messung(ML_XMM_XMM(DIVPS), MD_XMM_XMM(DIVPS), 1, 1)
    I$ = "DIVPS XMM, MEM128" : Messung(ML_XMM_MEM128(DIVPS), MD_XMM_MEM128(DIVPS), 1, 1) 
    I$ = "DIVSD XMM, XMM" : Messung(ML_XMM_XMM(DIVSD), MD_XMM_XMM(DIVSD), 1, 2)  
    I$ = "DIVSD XMM, MEM64" : Messung(ML_XMM_MEM64(DIVSD), MD_XMM_MEM64(DIVSD), 1, 2)
    I$ = "DIVSS XMM, XMM" : Messung(ML_XMM_XMM(DIVSS), MD_XMM_XMM(DIVSS), 1, 1)  
    I$ = "DIVSS XMM, MEM32" : Messung(ML_XMM_MEM32(DIVSS), MD_XMM_MEM32(DIVSS), 1, 1)
    I$ = "DPPD XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(DPPD, 3), MD_XMM_XMM_IMMFEST(DPPD, 3), 1, 5)
    I$ = "DPPD XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(DPPD, 3), MD_XMM_MEM128_IMMFEST(DPPD, 3), 1, 5)  ;???
    I$ = "DPPS XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(DPPS, 3), MD_XMM_XMM_IMMFEST(DPPS, 3), 1, 5)
    I$ = "DPPS XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(DPPS, 3), MD_XMM_MEM128_IMMFEST(DPPS, 3), 1, 5)  ;???  
    I$ = "HADDPD XMM, XMM" : Messung(ML_XMM_XMM(HADDPD), MD_XMM_XMM(HADDPD), 1, 3)
    I$ = "HADDPD XMM, MEM128" : Messung(ML_XMM_MEM128(HADDPD), MD_XMM_MEM128(HADDPD), 1, 3)  
    I$ = "HADDPS XMM, XMM" : Messung(ML_XMM_XMM(HADDPS), MD_XMM_XMM(HADDPS), 1, 3)
    I$ = "HADDPS XMM, MEM128" : Messung(ML_XMM_MEM128(HADDPS), MD_XMM_MEM128(HADDPS), 1, 3) 
    I$ = "HSUBPD XMM, XMM" : Messung(ML_XMM_XMM(HSUBPD), MD_XMM_XMM(HSUBPD), 1, 3)
    I$ = "HSUBPD XMM, MEM128" : Messung(ML_XMM_MEM128(HSUBPD), MD_XMM_MEM128(HSUBPD), 1, 3)  
    I$ = "HSUBPS XMM, XMM" : Messung(ML_XMM_XMM(HSUBPS), MD_XMM_XMM(HSUBPS), 1, 3)
    I$ = "HSUBPS XMM, MEM128" : Messung(ML_XMM_MEM128(HSUBPS), MD_XMM_MEM128(HSUBPS), 1, 3)     
    I$ = "MAXPD XMM, XMM" : Messung(ML_XMM_XMM(MAXPD), MD_XMM_XMM(MAXPD), 1, 2)
    I$ = "MAXPD XMM, MEM128" : Messung(ML_XMM_MEM128(MAXPD), MD_XMM_MEM128(MAXPD), 1, 2)   
    I$ = "MAXPS XMM, XMM" : Messung(ML_XMM_XMM(MAXPS), MD_XMM_XMM(MAXPS), 1, 1)
    I$ = "MAXPS XMM, MEM128" : Messung(ML_XMM_MEM128(MAXPS), MD_XMM_MEM128(MAXPS), 1, 1) 
    I$ = "MAXSD XMM, XMM" : Messung(ML_XMM_XMM(MAXSD), MD_XMM_XMM(MAXSD), 1, 2)  
    I$ = "MAXSD XMM, MEM64" : Messung(ML_XMM_MEM64(MAXSD), MD_XMM_MEM64(MAXSD), 1, 2)
    I$ = "MAXSS XMM, XMM" : Messung(ML_XMM_XMM(MAXSS), MD_XMM_XMM(MAXSS), 1, 1)  
    I$ = "MAXSS XMM, MEM32" : Messung(ML_XMM_MEM32(MAXSS), MD_XMM_MEM32(MAXSS), 1, 1)    
    I$ = "MINPD XMM, XMM" : Messung(ML_XMM_XMM(MINPD), MD_XMM_XMM(MINPD), 1, 2)
    I$ = "MINPD XMM, MEM128" : Messung(ML_XMM_MEM128(MINPD), MD_XMM_MEM128(MINPD), 1, 2)   
    I$ = "MINPS XMM, XMM" : Messung(ML_XMM_XMM(MINPS), MD_XMM_XMM(MINPS), 1, 1)
    I$ = "MINPS XMM, MEM128" : Messung(ML_XMM_MEM128(MINPS), MD_XMM_MEM128(MINPS), 1, 1) 
    I$ = "MINSD XMM, XMM" : Messung(ML_XMM_XMM(MINSD), MD_XMM_XMM(MINSD), 1, 2)  
    I$ = "MINSD XMM, MEM64" : Messung(ML_XMM_MEM64(MINSD), MD_XMM_MEM64(MINSD), 1, 2)
    I$ = "MINSS XMM, XMM" : Messung(ML_XMM_XMM(MINSS), MD_XMM_XMM(MINSS), 1, 1)  
    I$ = "MINSS XMM, MEM32" : Messung(ML_XMM_MEM32(MINSS), MD_XMM_MEM32(MINSS), 1, 1)  
    I$ = "MOVAPD XMM, XMM" : Messung(ML_XMM_XMM(MOVAPD), MD_XMM_XMM(MOVAPD), 1, 2)
    I$ = "MOVAPD XMM, MEM128" : Messung(ML_XMM_MEM128(MOVAPD), MD_XMM_MEM128(MOVAPD), 1, 2) 
    I$ = "MOVAPD MEM128, XMM" : Messung(ML_MEM128_XMM(MOVAPD), MD_MEM128_XMM(MOVAPD), 1, 2)    
    I$ = "MOVAPS XMM, XMM" : Messung(ML_XMM_XMM(MOVAPS), MD_XMM_XMM(MOVAPS), 1, 1)
    I$ = "MOVAPS XMM, MEM128" : Messung(ML_XMM_MEM128(MOVAPS), MD_XMM_MEM128(MOVAPS), 1, 1)  
    I$ = "MOVAPS MEM128, XMM" : Messung(ML_MEM128_XMM(MOVAPS), MD_MEM128_XMM(MOVAPS), 1, 1)     
    I$ = "MOVD XMM, REG32" : Messung(ML_XMM_REG32(MOVD), MD_XMM_REG32(MOVD), 1, 2) 
    I$ = "MOVD XMM, MEM32" : Messung(ML_XMM_MEM32(MOVD), MD_XMM_MEM32(MOVD), 1, 2) 
    I$ = "MOVD REG32, XMM" : Messung(ML_REG32_XMM(MOVD), MD_REG32_XMM(MOVD), 1, 2) 
    I$ = "MOVD MEM32, XMM" : Messung(ML_MEM32_XMM(MOVD), MD_MEM32_XMM(MOVD), 1, 2) 
    I$ = "MOVDDUP XMM, XMM" : Messung(ML_XMM_XMM(MOVDDUP), MD_XMM_XMM(MOVDDUP), 1, 3)  
    I$ = "MOVDDUP XMM, MEM64" : Messung(ML_XMM_MEM64(MOVDDUP), MD_XMM_MEM64(MOVDDUP), 1, 3)
    I$ = "MOVDQA XMM, XMM" : Messung(ML_XMM_XMM(MOVDQA), MD_XMM_XMM(MOVDQA), 1, 2)
    I$ = "MOVDQA XMM, MEM128" : Messung(ML_XMM_MEM128(MOVDQA), MD_XMM_MEM128(MOVDQA), 1, 2)     
    I$ = "MOVDQA MEM128, XMM" : Messung(ML_MEM128_XMM(MOVDQA), MD_MEM128_XMM(MOVDQA), 1, 2)     
    I$ = "MOVDQU XMM, XMM" : Messung(ML_XMM_XMM(MOVDQU), MD_XMM_XMM(MOVDQU), 1, 2)
    I$ = "MOVDQU XMM, MEM128  (aligned)" : Messung(ML_XMM_MEM128(MOVDQU), MD_XMM_MEM128(MOVDQU), 1, 2)     
    I$ = "MOVDQU XMM, MEM128  (non-aligned)" : Messung(ML_XMM_MEM128U(MOVDQU), MD_XMM_MEM128U(MOVDQU), 1, 2)    
    I$ = "MOVDQU MEM128, XMM  (aligned)" : Messung(ML_MEM128_XMM(MOVDQU), MD_MEM128_XMM(MOVDQU), 1, 2)
    I$ = "MOVDQU MEM128, XMM  (non-aligned)" : Messung(ML_MEM128U_XMM(MOVDQU), MD_MEM128U_XMM(MOVDQU), 1, 2)    
    I$ = "MOVHLPS XMM, XMM" : Messung(ML_XMM_XMM(MOVHLPS), MD_XMM_XMM(MOVHLPS), 1, 1)    
    I$ = "MOVHPD XMM, MEM64" : Messung(ML_XMM_MEM64(MOVHPD), MD_XMM_MEM64(MOVHPD), 1, 2)    
    I$ = "MOVHPD MEM64, XMM" : Messung(ML_MEM64_XMM(MOVHPD), MD_MEM64_XMM(MOVHPD), 1, 2)    
    I$ = "MOVHPS XMM, MEM64" : Messung(ML_XMM_MEM64(MOVHPS), MD_XMM_MEM64(MOVHPS), 1, 1)    
    I$ = "MOVHPS MEM64, XMM" : Messung(ML_MEM64_XMM(MOVHPS), MD_MEM64_XMM(MOVHPS), 1, 1)   
    I$ = "MOVLHPS XMM, XMM" : Messung(ML_XMM_XMM(MOVLHPS), MD_XMM_XMM(MOVLHPS), 1, 1)        
    I$ = "MOVLPD XMM, MEM64" : Messung(ML_XMM_MEM64(MOVLPD), MD_XMM_MEM64(MOVLPD), 1, 2)    
    I$ = "MOVLPD MEM64, XMM" : Messung(ML_MEM64_XMM(MOVLPD), MD_MEM64_XMM(MOVLPD), 1, 2)    
    I$ = "MOVLPS XMM, MEM64" : Messung(ML_XMM_MEM64(MOVLPS), MD_XMM_MEM64(MOVLPS), 1, 1)    
    I$ = "MOVLPS MEM64, XMM" : Messung(ML_MEM64_XMM(MOVLPS), MD_MEM64_XMM(MOVLPS), 1, 1)     
    I$ = "MOVMSKPD REG32, XMM" : Messung(ML_REG32_XMM(MOVMSKPD), MD_REG32_XMM(MOVMSKPD), 1, 2)
    I$ = "MOVMSKPS REG32, XMM" : Messung(ML_REG32_XMM(MOVMSKPS), MD_REG32_XMM(MOVMSKPS), 1, 1)
    I$ = "MOVNTDQA XMM, MEM128" : Messung(ML_XMM_MEM128(MOVNTDQA), MD_XMM_MEM128(MOVNTDQA), 1, 5)     
    I$ = "MOVNTDQ MEM128, XMM" : Messung(ML_MEM128_XMM(MOVNTDQ), MD_MEM128_XMM(MOVNTDQ), 1, 2)     
    I$ = "MOVQ XMM, MEM64" : Messung(ML_XMM_MEM64(MOVQ), MD_XMM_MEM64(MOVQ), 1, 2)
    I$ = "MOVQ MEM64, XMM" : Messung(ML_MEM64_XMM(MOVQ), MD_MEM64_XMM(MOVQ), 1, 2)     
    I$ = "MOVSD XMM, XMM" : Messung(ML_XMM_XMM(MOVSD), MD_XMM_XMM(MOVSD), 1, 2)  
    I$ = "MOVSD XMM, MEM64" : Messung(ML_XMM_MEM64(MOVSD), MD_XMM_MEM64(MOVSD), 1, 2)    
    I$ = "MOVSD MEM64, XMM" : Messung(ML_MEM64_XMM(MOVSD), MD_MEM64_XMM(MOVSD), 1, 2)   
    I$ = "MOVSHDUP XMM, XMM" : Messung(ML_XMM_XMM(MOVSHDUP), MD_XMM_XMM(MOVSHDUP), 1, 3)
    I$ = "MOVSHDUP XMM, MEM128" : Messung(ML_XMM_MEM128(MOVSHDUP), MD_XMM_MEM128(MOVSHDUP), 1, 3)   
    I$ = "MOVSLDUP XMM, XMM" : Messung(ML_XMM_XMM(MOVSLDUP), MD_XMM_XMM(MOVSLDUP), 1, 3)
    I$ = "MOVSLDUP XMM, MEM128" : Messung(ML_XMM_MEM128(MOVSLDUP), MD_XMM_MEM128(MOVSLDUP), 1, 3)    
    I$ = "MOVSS XMM, XMM" : Messung(ML_XMM_XMM(MOVSS), MD_XMM_XMM(MOVSS), 1, 1)  
    I$ = "MOVSS XMM, MEM32" : Messung(ML_XMM_MEM32(MOVSS), MD_XMM_MEM32(MOVSS), 1, 1)    
    I$ = "MOVSS MEM32, XMM" : Messung(ML_MEM32_XMM(MOVSS), MD_MEM32_XMM(MOVSS), 1, 1)    
    I$ = "MOVUPD XMM, XMM" : Messung(ML_XMM_XMM(MOVUPD), MD_XMM_XMM(MOVUPD), 1, 2)
    I$ = "MOVUPD XMM, MEM128  (aligned)" : Messung(ML_XMM_MEM128(MOVUPD), MD_XMM_MEM128(MOVUPD), 1, 2) 
    I$ = "MOVUPD XMM, MEM128  (non-aligned)" : Messung(ML_XMM_MEM128U(MOVUPD), MD_XMM_MEM128U(MOVUPD), 1, 2)    
    I$ = "MOVUPD MEM128, XMM  (aligned)" : Messung(ML_MEM128_XMM(MOVUPD), MD_MEM128_XMM(MOVUPD), 1, 2)
    I$ = "MOVUPD MEM128, XMM  (non-aligned)" : Messung(ML_MEM128U_XMM(MOVUPD), MD_MEM128U_XMM(MOVUPD), 1, 2)        
    I$ = "MOVUPS XMM, XMM" : Messung(ML_XMM_XMM(MOVUPS), MD_XMM_XMM(MOVUPS), 1, 1)
    I$ = "MOVUPS XMM, MEM128  (aligned)" : Messung(ML_XMM_MEM128(MOVUPS), MD_XMM_MEM128(MOVUPS), 1, 1) 
    I$ = "MOVUPS XMM, MEM128  (non-aligned)" : Messung(ML_XMM_MEM128U(MOVUPS), MD_XMM_MEM128U(MOVUPS), 1, 1) 
    I$ = "MOVUPS MEM128, XMM  (aligned)" : Messung(ML_MEM128_XMM(MOVUPS), MD_MEM128_XMM(MOVUPS), 1, 1)
    I$ = "MOVUPS MEM128, XMM  (non-aligned)" : Messung(ML_MEM128U_XMM(MOVUPS), MD_MEM128U_XMM(MOVUPS), 1, 1)
    I$ = "MPSADBW XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(MPSADBW, 3), MD_XMM_XMM_IMMFEST(MPSADBW, 3), 1, 5)
    I$ = "MPSADBW XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(MPSADBW, 3), MD_XMM_MEM128_IMMFEST(MPSADBW, 3), 1, 5)    
    I$ = "MULPD XMM, XMM" : Messung(ML_XMM_XMM(MULPD), MD_XMM_XMM(MULPD), 1, 2)
    I$ = "MULPD XMM, MEM128" : Messung(ML_XMM_MEM128(MULPD), MD_XMM_MEM128(MULPD), 1, 2)   
    I$ = "MULPS XMM, XMM" : Messung(ML_XMM_XMM(MULPS), MD_XMM_XMM(MULPS), 1, 1)
    I$ = "MULPS XMM, MEM128" : Messung(ML_XMM_MEM128(MULPS), MD_XMM_MEM128(MULPS), 1, 1) 
    I$ = "MULSD XMM, XMM" : Messung(ML_XMM_XMM(MULSD), MD_XMM_XMM(MULSD), 1, 2)  
    I$ = "MULSD XMM, MEM64" : Messung(ML_XMM_MEM64(MULSD), MD_XMM_MEM64(MULSD), 1, 2)
    I$ = "MULSS XMM, XMM" : Messung(ML_XMM_XMM(MULSS), MD_XMM_XMM(MULSS), 1, 1)  
    I$ = "MULSS XMM, MEM32" : Messung(ML_XMM_MEM32(MULSS), MD_XMM_MEM32(MULSS), 1, 1)
    I$ = "ORPD XMM, XMM" : Messung(ML_XMM_XMM(ORPD), MD_XMM_XMM(ORPD), 1, 2)
    I$ = "ORPD XMM, MEM128" : Messung(ML_XMM_MEM128(ORPD), MD_XMM_MEM128(ORPD), 1, 2)   
    I$ = "ORPS XMM, XMM" : Messung(ML_XMM_XMM(ORPS), MD_XMM_XMM(ORPS), 1, 1)
    I$ = "ORPS XMM, MEM128" : Messung(ML_XMM_MEM128(ORPS), MD_XMM_MEM128(ORPS), 1, 1)
    I$ = "PABSB XMM, XMM" : Messung(ML_XMM_XMM(PABSB), MD_XMM_XMM(PABSB), 1, 4)
    I$ = "PABSB XMM, MEM128" : Messung(ML_XMM_MEM128(PABSB), MD_XMM_MEM128(PABSB), 1, 4)
    I$ = "PABSW XMM, XMM" : Messung(ML_XMM_XMM(PABSW), MD_XMM_XMM(PABSW), 1, 4)
    I$ = "PABSW XMM, MEM128" : Messung(ML_XMM_MEM128(PABSW), MD_XMM_MEM128(PABSW), 1, 4)
    I$ = "PABSD XMM, XMM" : Messung(ML_XMM_XMM(PABSD), MD_XMM_XMM(PABSD), 1, 4)
    I$ = "PABSD XMM, MEM128" : Messung(ML_XMM_MEM128(PABSD), MD_XMM_MEM128(PABSD), 1, 4)
    I$ = "PACKSSWB XMM, XMM" : Messung(ML_XMM_XMM(PACKSSWB), MD_XMM_XMM(PACKSSWB), 1, 2)
    I$ = "PACKSSWB XMM, MEM128" : Messung(ML_XMM_MEM128(PACKSSWB), MD_XMM_MEM128(PACKSSWB), 1, 2)
    I$ = "PACKSSDW XMM, XMM" : Messung(ML_XMM_XMM(PACKSSDW), MD_XMM_XMM(PACKSSDW), 1, 2)
    I$ = "PACKSSDW XMM, MEM128" : Messung(ML_XMM_MEM128(PACKSSDW), MD_XMM_MEM128(PACKSSDW), 1, 2)
    I$ = "PACKUSDW XMM, XMM" : Messung(ML_XMM_XMM(PACKUSDW), MD_XMM_XMM(PACKUSDW), 1, 5)
    I$ = "PACKUSDW XMM, MEM128" : Messung(ML_XMM_MEM128(PACKUSDW), MD_XMM_MEM128(PACKUSDW), 1, 5)
    I$ = "PACKUSWB XMM, XMM" : Messung(ML_XMM_XMM(PACKUSWB), MD_XMM_XMM(PACKUSWB), 1, 2)
    I$ = "PACKUSWB XMM, MEM128" : Messung(ML_XMM_MEM128(PACKUSWB), MD_XMM_MEM128(PACKUSWB), 1, 2)
    I$ = "PADDB XMM, XMM" : Messung(ML_XMM_XMM(PADDB), MD_XMM_XMM(PADDB), 1, 2)
    I$ = "PADDB XMM, MEM128" : Messung(ML_XMM_MEM128(PADDB), MD_XMM_MEM128(PADDB), 1, 2)
    I$ = "PADDW XMM, XMM" : Messung(ML_XMM_XMM(PADDW), MD_XMM_XMM(PADDW), 1, 2)
    I$ = "PADDW XMM, MEM128" : Messung(ML_XMM_MEM128(PADDW), MD_XMM_MEM128(PADDW), 1, 2)
    I$ = "PADDD XMM, XMM" : Messung(ML_XMM_XMM(PADDD), MD_XMM_XMM(PADDD), 1, 2)
    I$ = "PADDD XMM, MEM128" : Messung(ML_XMM_MEM128(PADDD), MD_XMM_MEM128(PADDD), 1, 2)
    I$ = "PADDQ XMM, XMM" : Messung(ML_XMM_XMM(PADDQ), MD_XMM_XMM(PADDQ), 1, 2)
    I$ = "PADDQ XMM, MEM128" : Messung(ML_XMM_MEM128(PADDQ), MD_XMM_MEM128(PADDQ), 1, 2)
    I$ = "PADDSB XMM, XMM" : Messung(ML_XMM_XMM(PADDSB), MD_XMM_XMM(PADDSB), 1, 2)
    I$ = "PADDSB XMM, MEM128" : Messung(ML_XMM_MEM128(PADDSB), MD_XMM_MEM128(PADDSB), 1, 2)
    I$ = "PADDSW XMM, XMM" : Messung(ML_XMM_XMM(PADDSW), MD_XMM_XMM(PADDSW), 1, 2)
    I$ = "PADDSW XMM, MEM128" : Messung(ML_XMM_MEM128(PADDSW), MD_XMM_MEM128(PADDSW), 1, 2)
    I$ = "PADDUSB XMM, XMM" : Messung(ML_XMM_XMM(PADDUSB), MD_XMM_XMM(PADDUSB), 1, 2)
    I$ = "PADDUSB XMM, MEM128" : Messung(ML_XMM_MEM128(PADDUSB), MD_XMM_MEM128(PADDUSB), 1, 2)
    I$ = "PADDUSW XMM, XMM" : Messung(ML_XMM_XMM(PADDUSW), MD_XMM_XMM(PADDUSW), 1, 2)
    I$ = "PADDUSW XMM, MEM128" : Messung(ML_XMM_MEM128(PADDUSW), MD_XMM_MEM128(PADDUSW), 1, 2)
    I$ = "PALIGNR XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PALIGNR, 1), MD_XMM_XMM_IMMFEST(PALIGNR, 1), 1, 4)
    I$ = "PALIGNR XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PALIGNR, 1), MD_XMM_MEM128_IMMFEST(PALIGNR, 1), 1, 4)     
    I$ = "PAND XMM, XMM" : Messung(ML_XMM_XMM(PAND), MD_XMM_XMM(PAND), 1, 2)  
    I$ = "PAND XMM, MEM128" : Messung(ML_XMM_MEM128(PAND), MD_XMM_MEM128(PAND), 1, 2)
    I$ = "PANDN XMM, XMM" : Messung(ML_XMM_XMM(PANDN), MD_XMM_XMM(PANDN), 1, 2)  
    I$ = "PANDN XMM, MEM128" : Messung(ML_XMM_MEM128(PANDN), MD_XMM_MEM128(PANDN), 1, 2)
    I$ = "PAVGB XMM, XMM" : Messung(ML_XMM_XMM(PAVGB), MD_XMM_XMM(PAVGB), 1, 2)  
    I$ = "PAVGB XMM, MEM128" : Messung(ML_XMM_MEM128(PAVGB), MD_XMM_MEM128(PAVGB), 1, 2)
    I$ = "PAVGW XMM, XMM" : Messung(ML_XMM_XMM(PAVGW), MD_XMM_XMM(PAVGW), 1, 2)  
    I$ = "PAVGW XMM, MEM128" : Messung(ML_XMM_MEM128(PAVGW), MD_XMM_MEM128(PAVGW), 1, 2)
    I$ = "PBLENDVB XMM, XMM, XMM0" : Messung(ML_XMM_XMM_XMM0(PBLENDVB), MD_XMM_XMM_XMM0(PBLENDVB), 1, 5)
    I$ = "PBLENDVB XMM, MEM128, XMM0" : Messung(ML_XMM_MEM128_XMM0(PBLENDVB), MD_XMM_MEM128_XMM0(PBLENDVB), 1, 5)   
    I$ = "PBLENDW XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PBLENDW, 1), MD_XMM_XMM_IMMFEST(PBLENDW, 1), 1, 5)
    I$ = "PBLENDW XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PBLENDW, 1), MD_XMM_MEM128_IMMFEST(PBLENDW, 1), 1, 5)  
    I$ = "PCMPEQB XMM, XMM" : Messung(ML_XMM_XMM(PCMPEQB), MD_XMM_XMM(PCMPEQB), 1, 2)
    I$ = "PCMPEQB XMM, MEM128" : Messung(ML_XMM_MEM128(PCMPEQB), MD_XMM_MEM128(PCMPEQB), 1, 2)
    I$ = "PCMPEQW XMM, XMM" : Messung(ML_XMM_XMM(PCMPEQW), MD_XMM_XMM(PCMPEQW), 1, 2)
    I$ = "PCMPEQW XMM, MEM128" : Messung(ML_XMM_MEM128(PCMPEQW), MD_XMM_MEM128(PCMPEQW), 1, 2)
    I$ = "PCMPEQD XMM, XMM" : Messung(ML_XMM_XMM(PCMPEQD), MD_XMM_XMM(PCMPEQD), 1, 2)
    I$ = "PCMPEQD XMM, MEM128" : Messung(ML_XMM_MEM128(PCMPEQD), MD_XMM_MEM128(PCMPEQD), 1, 2)
    I$ = "PCMPEQQ XMM, XMM" : Messung(ML_XMM_XMM(PCMPEQQ), MD_XMM_XMM(PCMPEQQ), 1, 5)
    I$ = "PCMPEQQ XMM, MEM128" : Messung(ML_XMM_MEM128(PCMPEQQ), MD_XMM_MEM128(PCMPEQQ), 1, 5)
    I$ = "PCMPESTRI XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PCMPESTRI, 1), MD_XMM_XMM_IMMFEST(PCMPESTRI, 1), 1, 6)
    I$ = "PCMPESTRI XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PCMPESTRI, 1), MD_XMM_MEM128_IMMFEST(PCMPESTRI, 1), 1, 6)  
    I$ = "PCMPESTRM XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PCMPESTRM, 1), MD_XMM_XMM_IMMFEST(PCMPESTRM, 1), 1, 6)
    I$ = "PCMPESTRM XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PCMPESTRM, 1), MD_XMM_MEM128_IMMFEST(PCMPESTRM, 1), 1, 6)  
    I$ = "PCMPISTRI XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PCMPISTRI, 1), MD_XMM_XMM_IMMFEST(PCMPISTRI, 1), 1, 6)
    I$ = "PCMPISTRI XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PCMPISTRI, 1), MD_XMM_MEM128_IMMFEST(PCMPISTRI, 1), 1, 6)  
    I$ = "PCMPISTRM XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PCMPISTRM, 1), MD_XMM_XMM_IMMFEST(PCMPISTRM, 1), 1, 6)
    I$ = "PCMPISTRM XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PCMPISTRM, 1), MD_XMM_MEM128_IMMFEST(PCMPISTRM, 1), 1, 6)  
    I$ = "PCMPGTB XMM, XMM" : Messung(ML_XMM_XMM(PCMPGTB), MD_XMM_XMM(PCMPGTB), 1, 2)
    I$ = "PCMPGTB XMM, MEM128" : Messung(ML_XMM_MEM128(PCMPGTB), MD_XMM_MEM128(PCMPGTB), 1, 2)
    I$ = "PCMPGTW XMM, XMM" : Messung(ML_XMM_XMM(PCMPGTW), MD_XMM_XMM(PCMPGTW), 1, 2)
    I$ = "PCMPGTW XMM, MEM128" : Messung(ML_XMM_MEM128(PCMPGTW), MD_XMM_MEM128(PCMPGTW), 1, 2)
    I$ = "PCMPGTD XMM, XMM" : Messung(ML_XMM_XMM(PCMPGTD), MD_XMM_XMM(PCMPGTD), 1, 2)
    I$ = "PCMPGTD XMM, MEM128" : Messung(ML_XMM_MEM128(PCMPGTD), MD_XMM_MEM128(PCMPGTD), 1, 2)
    I$ = "PCMPGTQ XMM, XMM" : Messung(ML_XMM_XMM(PCMPGTQ), MD_XMM_XMM(PCMPGTQ), 1, 6)
    I$ = "PCMPGTQ XMM, MEM128" : Messung(ML_XMM_MEM128(PCMPGTQ), MD_XMM_MEM128(PCMPGTQ), 1, 6)
    ;PEXTRB, PEXTRW, PEXTRD   evtl. mal
    I$ = "PHADDW XMM, XMM" : Messung(ML_XMM_XMM(PHADDW), MD_XMM_XMM(PHADDW), 1, 4)
    I$ = "PHADDW XMM, MEM128" : Messung(ML_XMM_MEM128(PHADDW), MD_XMM_MEM128(PHADDW), 1, 4)
    I$ = "PHADDD XMM, XMM" : Messung(ML_XMM_XMM(PHADDD), MD_XMM_XMM(PHADDD), 1, 4)
    I$ = "PHADDD XMM, MEM128" : Messung(ML_XMM_MEM128(PHADDD), MD_XMM_MEM128(PHADDD), 1, 4)
    I$ = "PHADDSW XMM, XMM" : Messung(ML_XMM_XMM(PHADDSW), MD_XMM_XMM(PHADDSW), 1, 4)
    I$ = "PHADDSW XMM, MEM128" : Messung(ML_XMM_MEM128(PHADDSW), MD_XMM_MEM128(PHADDSW), 1, 4)
    I$ = "PHMINPOSUW XMM, XMM" : Messung(ML_XMM_XMM(PHMINPOSUW), MD_XMM_XMM(PHMINPOSUW), 1, 5)
    I$ = "PHMINPOSUW XMM, MEM128" : Messung(ML_XMM_MEM128(PHMINPOSUW), MD_XMM_MEM128(PHMINPOSUW), 1, 5)
    I$ = "PHSUBW XMM, XMM" : Messung(ML_XMM_XMM(PHSUBW), MD_XMM_XMM(PHSUBW), 1, 4)
    I$ = "PHSUBW XMM, MEM128" : Messung(ML_XMM_MEM128(PHSUBW), MD_XMM_MEM128(PHSUBW), 1, 4)
    I$ = "PHSUBD XMM, XMM" : Messung(ML_XMM_XMM(PHSUBD), MD_XMM_XMM(PHSUBD), 1, 4)
    I$ = "PHSUBD XMM, MEM128" : Messung(ML_XMM_MEM128(PHSUBD), MD_XMM_MEM128(PHSUBD), 1, 4)
    I$ = "PHSUBSW XMM, XMM" : Messung(ML_XMM_XMM(PHSUBSW), MD_XMM_XMM(PHSUBSW), 1, 4)
    I$ = "PHSUBSW XMM, MEM128" : Messung(ML_XMM_MEM128(PHSUBSW), MD_XMM_MEM128(PHSUBSW), 1, 4)
    ;PINSRB, PINSRW, PINSRD, PINSRQ   evtl. mal
    I$ = "PMADDUBSW XMM, XMM" : Messung(ML_XMM_XMM(PMADDUBSW), MD_XMM_XMM(PMADDUBSW), 1, 4)
    I$ = "PMADDUBSW XMM, MEM128" : Messung(ML_XMM_MEM128(PMADDUBSW), MD_XMM_MEM128(PMADDUBSW), 1, 4)
    I$ = "PMADDWD XMM, XMM" : Messung(ML_XMM_XMM(PMADDWD), MD_XMM_XMM(PMADDWD), 1, 2)
    I$ = "PMADDWD XMM, MEM128" : Messung(ML_XMM_MEM128(PMADDWD), MD_XMM_MEM128(PMADDWD), 1, 2)
    I$ = "PMAXSB XMM, XMM" : Messung(ML_XMM_XMM(PMAXSB), MD_XMM_XMM(PMAXSB), 1, 5)
    I$ = "PMAXSB XMM, MEM128" : Messung(ML_XMM_MEM128(PMAXSB), MD_XMM_MEM128(PMAXSB), 1, 5)
    I$ = "PMAXSD XMM, XMM" : Messung(ML_XMM_XMM(PMAXSD), MD_XMM_XMM(PMAXSD), 1, 5)
    I$ = "PMAXSD XMM, MEM128" : Messung(ML_XMM_MEM128(PMAXSD), MD_XMM_MEM128(PMAXSD), 1, 5)
    I$ = "PMAXSW XMM, XMM" : Messung(ML_XMM_XMM(PMAXSW), MD_XMM_XMM(PMAXSW), 1, 2)
    I$ = "PMAXSW XMM, MEM128" : Messung(ML_XMM_MEM128(PMAXSW), MD_XMM_MEM128(PMAXSW), 1, 2)
    I$ = "PMAXUB XMM, XMM" : Messung(ML_XMM_XMM(PMAXUB), MD_XMM_XMM(PMAXUB), 1, 2)
    I$ = "PMAXUB XMM, MEM128" : Messung(ML_XMM_MEM128(PMAXUB), MD_XMM_MEM128(PMAXUB), 1, 2)
    I$ = "PMAXUD XMM, XMM" : Messung(ML_XMM_XMM(PMAXUD), MD_XMM_XMM(PMAXUD), 1, 5)
    I$ = "PMAXUD XMM, MEM128" : Messung(ML_XMM_MEM128(PMAXUD), MD_XMM_MEM128(PMAXUD), 1, 5)
    I$ = "PMAXUW XMM, XMM" : Messung(ML_XMM_XMM(PMAXUW), MD_XMM_XMM(PMAXUW), 1, 5)
    I$ = "PMAXUW XMM, MEM128" : Messung(ML_XMM_MEM128(PMAXUW), MD_XMM_MEM128(PMAXUW), 1, 5)
    I$ = "PMINSB XMM, XMM" : Messung(ML_XMM_XMM(PMINSB), MD_XMM_XMM(PMINSB), 1, 5)
    I$ = "PMINSB XMM, MEM128" : Messung(ML_XMM_MEM128(PMINSB), MD_XMM_MEM128(PMINSB), 1, 5)
    I$ = "PMINSD XMM, XMM" : Messung(ML_XMM_XMM(PMINSD), MD_XMM_XMM(PMINSD), 1, 5)
    I$ = "PMINSD XMM, MEM128" : Messung(ML_XMM_MEM128(PMINSD), MD_XMM_MEM128(PMINSD), 1, 5)
    I$ = "PMINSW XMM, XMM" : Messung(ML_XMM_XMM(PMINSW), MD_XMM_XMM(PMINSW), 1, 2)
    I$ = "PMINSW XMM, MEM128" : Messung(ML_XMM_MEM128(PMINSW), MD_XMM_MEM128(PMINSW), 1, 2)
    I$ = "PMINUB XMM, XMM" : Messung(ML_XMM_XMM(PMINUB), MD_XMM_XMM(PMINUB), 1, 2)
    I$ = "PMINUB XMM, MEM128" : Messung(ML_XMM_MEM128(PMINUB), MD_XMM_MEM128(PMINUB), 1, 2)
    I$ = "PMINUD XMM, XMM" : Messung(ML_XMM_XMM(PMINUD), MD_XMM_XMM(PMINUD), 1, 5)
    I$ = "PMINUD XMM, MEM128" : Messung(ML_XMM_MEM128(PMINUD), MD_XMM_MEM128(PMINUD), 1, 5)
    I$ = "PMINUW XMM, XMM" : Messung(ML_XMM_XMM(PMINUW), MD_XMM_XMM(PMINUW), 1, 5)
    I$ = "PMINUW XMM, MEM128" : Messung(ML_XMM_MEM128(PMINUW), MD_XMM_MEM128(PMINUW), 1, 5)
    I$ = "PMOVMSKB REG32, XMM" : Messung(ML_REG32_XMM(PMOVMSKB), MD_REG32_XMM(PMOVMSKB), 1, 2)
    I$ = "PMOVSXBW XMM, XMM" : Messung(ML_XMM_XMM(PMOVSXBW), MD_XMM_XMM(PMOVSXBW), 1, 5)  
    I$ = "PMOVSXBW XMM, MEM64" : Messung(ML_XMM_MEM64(PMOVSXBW), MD_XMM_MEM64(PMOVSXBW), 1, 5)
;+... FAsm 
    I$ = "PMOVZXBW XMM, XMM" : Messung(ML_XMM_XMM(PMOVZXBW), MD_XMM_XMM(PMOVZXBW), 1, 5)  
    I$ = "PMOVZXBW XMM, MEM64" : Messung(ML_XMM_MEM64(PMOVZXBW), MD_XMM_MEM64(PMOVZXBW), 1, 5)
;+... FAsm 
    I$ = "PMULDQ XMM, XMM" : Messung(ML_XMM_XMM(PMULDQ), MD_XMM_XMM(PMULDQ), 1, 5)
    I$ = "PMULDQ XMM, MEM128" : Messung(ML_XMM_MEM128(PMULDQ), MD_XMM_MEM128(PMULDQ), 1, 5)
    I$ = "PMULHRSW XMM, XMM" : Messung(ML_XMM_XMM(PMULHRSW), MD_XMM_XMM(PMULHRSW), 1, 4)
    I$ = "PMULHRSW XMM, MEM128" : Messung(ML_XMM_MEM128(PMULHRSW), MD_XMM_MEM128(PMULHRSW), 1, 4)
    I$ = "PMULHUW XMM, XMM" : Messung(ML_XMM_XMM(PMULHUW), MD_XMM_XMM(PMULHUW), 1, 2)
    I$ = "PMULHUW XMM, MEM128" : Messung(ML_XMM_MEM128(PMULHUW), MD_XMM_MEM128(PMULHUW), 1, 2)
    I$ = "PMULHW XMM, XMM" : Messung(ML_XMM_XMM(PMULHW), MD_XMM_XMM(PMULHW), 1, 2)
    I$ = "PMULHW XMM, MEM128" : Messung(ML_XMM_MEM128(PMULHW), MD_XMM_MEM128(PMULHW), 1, 2)
    I$ = "PMULLD XMM, XMM" : Messung(ML_XMM_XMM(PMULLD), MD_XMM_XMM(PMULLD), 1, 5)
    I$ = "PMULLD XMM, MEM128" : Messung(ML_XMM_MEM128(PMULLD), MD_XMM_MEM128(PMULLD), 1, 5)
    I$ = "PMULLW XMM, XMM" : Messung(ML_XMM_XMM(PMULLW), MD_XMM_XMM(PMULLW), 1, 2)
    I$ = "PMULLW XMM, MEM128" : Messung(ML_XMM_MEM128(PMULLW), MD_XMM_MEM128(PMULLW), 1, 2)
    I$ = "PMULUDQ XMM, XMM" : Messung(ML_XMM_XMM(PMULUDQ), MD_XMM_XMM(PMULUDQ), 1, 2)
    I$ = "PMULUDQ XMM, MEM128" : Messung(ML_XMM_MEM128(PMULUDQ), MD_XMM_MEM128(PMULUDQ), 1, 2)
    I$ = "POR XMM, XMM" : Messung(ML_XMM_XMM(POR), MD_XMM_XMM(POR), 1, 2)  
    I$ = "POR XMM, MEM128" : Messung(ML_XMM_MEM128(POR), MD_XMM_MEM128(POR), 1, 2)
    I$ = "PSADBW XMM, XMM" : Messung(ML_XMM_XMM(PSADBW), MD_XMM_XMM(PSADBW), 1, 2)
    I$ = "PSADBW XMM, MEM128" : Messung(ML_XMM_MEM128(PSADBW), MD_XMM_MEM128(PSADBW), 1, 2)
    I$ = "PSHUFB XMM, XMM" : Messung(ML_XMM_XMM(PSHUFB), MD_XMM_XMM(PSHUFB), 1, 4)
    I$ = "PSHUFB XMM, MEM128" : Messung(ML_XMM_MEM128(PSHUFB), MD_XMM_MEM128(PSHUFB), 1, 4)
    I$ = "PSHUFD XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PSHUFD, 3), MD_XMM_XMM_IMMFEST(PSHUFD, 3), 1, 2)
    I$ = "PSHUFD XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PSHUFD, 3), MD_XMM_MEM128_IMMFEST(PSHUFD, 3), 1, 2)   
    I$ = "PSHUFHW XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PSHUFHW, 3), MD_XMM_XMM_IMMFEST(PSHUFHW, 3), 1, 2)
    I$ = "PSHUFHW XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PSHUFHW, 3), MD_XMM_MEM128_IMMFEST(PSHUFHW, 3), 1, 2)   
    I$ = "PSHUFLW XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(PSHUFLW, 3), MD_XMM_XMM_IMMFEST(PSHUFLW, 3), 1, 2)
    I$ = "PSHUFLW XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(PSHUFLW, 3), MD_XMM_MEM128_IMMFEST(PSHUFLW, 3), 1, 2) 
    I$ = "PSIGNB XMM, XMM" : Messung(ML_XMM_XMM(PSIGNB), MD_XMM_XMM(PSIGNB), 1, 4)
    I$ = "PSIGNB XMM, MEM128" : Messung(ML_XMM_MEM128(PSIGNB), MD_XMM_MEM128(PSIGNB), 1, 4)
    I$ = "PSIGNW XMM, XMM" : Messung(ML_XMM_XMM(PSIGNW), MD_XMM_XMM(PSIGNW), 1, 4)
    I$ = "PSIGNW XMM, MEM128" : Messung(ML_XMM_MEM128(PSIGNW), MD_XMM_MEM128(PSIGNW), 1, 4)
    I$ = "PSIGND XMM, XMM" : Messung(ML_XMM_XMM(PSIGND), MD_XMM_XMM(PSIGND), 1, 4)
    I$ = "PSIGND XMM, MEM128" : Messung(ML_XMM_MEM128(PSIGND), MD_XMM_MEM128(PSIGND), 1, 4)
    I$ = "PSLLDQ XMM, Const8" : Messung(ML_XMM_IMMFEST(PSLLDQ, 3), MD_XMM_IMMFEST(PSLLDQ, 3), 1, 2)   
    I$ = "PSLLW XMM, XMM" : Messung(ML_XMM_XMM(PSLLW), MD_XMM_XMM(PSLLW), 1, 2)
    I$ = "PSLLW XMM, MEM128" : Messung(ML_XMM_MEM128(PSLLW), MD_XMM_MEM128(PSLLW), 1, 2)
    I$ = "PSLLW XMM, Const8" : Messung(ML_XMM_IMMFEST(PSLLW, 3), MD_XMM_IMMFEST(PSLLW, 3), 1, 2)   
    I$ = "PSLLD XMM, XMM" : Messung(ML_XMM_XMM(PSLLD), MD_XMM_XMM(PSLLD), 1, 2)
    I$ = "PSLLD XMM, MEM128" : Messung(ML_XMM_MEM128(PSLLD), MD_XMM_MEM128(PSLLD), 1, 2)
    I$ = "PSLLD XMM, Const8" : Messung(ML_XMM_IMMFEST(PSLLD, 3), MD_XMM_IMMFEST(PSLLD, 3), 1, 2)
    I$ = "PSLLQ XMM, XMM" : Messung(ML_XMM_XMM(PSLLQ), MD_XMM_XMM(PSLLQ), 1, 2)
    I$ = "PSLLQ XMM, MEM128" : Messung(ML_XMM_MEM128(PSLLQ), MD_XMM_MEM128(PSLLQ), 1, 2)
    I$ = "PSLLQ XMM, Const8" : Messung(ML_XMM_IMMFEST(PSLLQ, 3), MD_XMM_IMMFEST(PSLLQ, 3), 1, 2)
    I$ = "PSRAW XMM, XMM" : Messung(ML_XMM_XMM(PSRAW), MD_XMM_XMM(PSRAW), 1, 2)
    I$ = "PSRAW XMM, MEM128" : Messung(ML_XMM_MEM128(PSRAW), MD_XMM_MEM128(PSRAW), 1, 2)
    I$ = "PSRAW XMM, Const8" : Messung(ML_XMM_IMMFEST(PSRAW, 3), MD_XMM_IMMFEST(PSRAW, 3), 1, 2)
    I$ = "PSRAD XMM, XMM" : Messung(ML_XMM_XMM(PSRAD), MD_XMM_XMM(PSRAD), 1, 2)
    I$ = "PSRAD XMM, MEM128" : Messung(ML_XMM_MEM128(PSRAD), MD_XMM_MEM128(PSRAD), 1, 2)
    I$ = "PSRAD XMM, Const8" : Messung(ML_XMM_IMMFEST(PSRAD, 3), MD_XMM_IMMFEST(PSRAD, 3), 1, 2)    
    I$ = "PSRLDQ XMM, Const8" : Messung(ML_XMM_IMMFEST(PSRLDQ, 3), MD_XMM_IMMFEST(PSRLDQ, 3), 1, 2)     
    I$ = "PSRLW XMM, XMM" : Messung(ML_XMM_XMM(PSRLW), MD_XMM_XMM(PSRLW), 1, 2)
    I$ = "PSRLW XMM, MEM128" : Messung(ML_XMM_MEM128(PSRLW), MD_XMM_MEM128(PSRLW), 1, 2)
    I$ = "PSRLW XMM, Const8" : Messung(ML_XMM_IMMFEST(PSRLW, 3), MD_XMM_IMMFEST(PSRLW, 3), 1, 2)   
    I$ = "PSRLD XMM, XMM" : Messung(ML_XMM_XMM(PSRLD), MD_XMM_XMM(PSRLD), 1, 2)
    I$ = "PSRLD XMM, MEM128" : Messung(ML_XMM_MEM128(PSRLD), MD_XMM_MEM128(PSRLD), 1, 2)
    I$ = "PSRLD XMM, Const8" : Messung(ML_XMM_IMMFEST(PSRLD, 3), MD_XMM_IMMFEST(PSRLD, 3), 1, 2)
    I$ = "PSRLQ XMM, XMM" : Messung(ML_XMM_XMM(PSRLQ), MD_XMM_XMM(PSRLQ), 1, 2)
    I$ = "PSRLQ XMM, MEM128" : Messung(ML_XMM_MEM128(PSRLQ), MD_XMM_MEM128(PSRLQ), 1, 2)
    I$ = "PSRLQ XMM, Const8" : Messung(ML_XMM_IMMFEST(PSRLQ, 3), MD_XMM_IMMFEST(PSRLQ, 3), 1, 2) 
    I$ = "PSUBB XMM, XMM" : Messung(ML_XMM_XMM(PSUBB), MD_XMM_XMM(PSUBB), 1, 2)
    I$ = "PSUBB XMM, MEM128" : Messung(ML_XMM_MEM128(PSUBB), MD_XMM_MEM128(PSUBB), 1, 2)
    I$ = "PSUBW XMM, XMM" : Messung(ML_XMM_XMM(PSUBW), MD_XMM_XMM(PSUBW), 1, 2)
    I$ = "PSUBW XMM, MEM128" : Messung(ML_XMM_MEM128(PSUBW), MD_XMM_MEM128(PSUBW), 1, 2)
    I$ = "PSUBD XMM, XMM" : Messung(ML_XMM_XMM(PSUBD), MD_XMM_XMM(PSUBD), 1, 2)
    I$ = "PSUBD XMM, MEM128" : Messung(ML_XMM_MEM128(PSUBD), MD_XMM_MEM128(PSUBD), 1, 2)
    I$ = "PSUBQ XMM, XMM" : Messung(ML_XMM_XMM(PSUBQ), MD_XMM_XMM(PSUBQ), 1, 2)
    I$ = "PSUBQ XMM, MEM128" : Messung(ML_XMM_MEM128(PSUBQ), MD_XMM_MEM128(PSUBQ), 1, 2)
    I$ = "PSUBSB XMM, XMM" : Messung(ML_XMM_XMM(PSUBSB), MD_XMM_XMM(PSUBSB), 1, 2)
    I$ = "PSUBSB XMM, MEM128" : Messung(ML_XMM_MEM128(PSUBSB), MD_XMM_MEM128(PSUBSB), 1, 2)
    I$ = "PSUBSW XMM, XMM" : Messung(ML_XMM_XMM(PSUBSW), MD_XMM_XMM(PSUBSW), 1, 2)
    I$ = "PSUBSW XMM, MEM128" : Messung(ML_XMM_MEM128(PSUBSW), MD_XMM_MEM128(PSUBSW), 1, 2)
    I$ = "PSUBUSB XMM, XMM" : Messung(ML_XMM_XMM(PSUBUSB), MD_XMM_XMM(PSUBUSB), 1, 2)
    I$ = "PSUBUSB XMM, MEM128" : Messung(ML_XMM_MEM128(PSUBUSB), MD_XMM_MEM128(PSUBUSB), 1, 2)
    I$ = "PSUBUSW XMM, XMM" : Messung(ML_XMM_XMM(PSUBUSW), MD_XMM_XMM(PSUBUSW), 1, 2)
    I$ = "PSUBUSW XMM, MEM128" : Messung(ML_XMM_MEM128(PSUBUSW), MD_XMM_MEM128(PSUBUSW), 1, 2)
    I$ = "PTEST XMM, XMM" : Messung(ML_XMM_XMM(PTEST), MD_XMM_XMM(PTEST), 1, 5)
    I$ = "PTEST XMM, MEM128" : Messung(ML_XMM_MEM128(PTEST), MD_XMM_MEM128(PTEST), 1, 5)
    I$ = "PUNPCKHBW XMM, XMM" : Messung(ML_XMM_XMM(PUNPCKHBW), MD_XMM_XMM(PUNPCKHBW), 1, 2)
    I$ = "PUNPCKHBW XMM, MEM128" : Messung(ML_XMM_MEM128(PUNPCKHBW), MD_XMM_MEM128(PUNPCKHBW), 1, 2)
    I$ = "PUNPCKHWD XMM, XMM" : Messung(ML_XMM_XMM(PUNPCKHWD), MD_XMM_XMM(PUNPCKHWD), 1, 2)
    I$ = "PUNPCKHWD XMM, MEM128" : Messung(ML_XMM_MEM128(PUNPCKHWD), MD_XMM_MEM128(PUNPCKHWD), 1, 2)
    I$ = "PUNPCKHDQ XMM, XMM" : Messung(ML_XMM_XMM(PUNPCKHDQ), MD_XMM_XMM(PUNPCKHDQ), 1, 2)
    I$ = "PUNPCKHDQ XMM, MEM128" : Messung(ML_XMM_MEM128(PUNPCKHDQ), MD_XMM_MEM128(PUNPCKHDQ), 1, 2)
    I$ = "PUNPCKHQDQ XMM, XMM" : Messung(ML_XMM_XMM(PUNPCKHQDQ), MD_XMM_XMM(PUNPCKHQDQ), 1, 2)
    I$ = "PUNPCKHQDQ XMM, MEM128" : Messung(ML_XMM_MEM128(PUNPCKHQDQ), MD_XMM_MEM128(PUNPCKHQDQ), 1, 2)
    I$ = "PUNPCKLBW XMM, XMM" : Messung(ML_XMM_XMM(PUNPCKLBW), MD_XMM_XMM(PUNPCKLBW), 1, 2)
    I$ = "PUNPCKLBW XMM, MEM128" : Messung(ML_XMM_MEM128(PUNPCKLBW), MD_XMM_MEM128(PUNPCKLBW), 1, 2)
    I$ = "PUNPCKLWD XMM, XMM" : Messung(ML_XMM_XMM(PUNPCKLWD), MD_XMM_XMM(PUNPCKLWD), 1, 2)
    I$ = "PUNPCKLWD XMM, MEM128" : Messung(ML_XMM_MEM128(PUNPCKLWD), MD_XMM_MEM128(PUNPCKLWD), 1, 2)
    I$ = "PUNPCKLDQ XMM, XMM" : Messung(ML_XMM_XMM(PUNPCKLDQ), MD_XMM_XMM(PUNPCKLDQ), 1, 2)
    I$ = "PUNPCKLDQ XMM, MEM128" : Messung(ML_XMM_MEM128(PUNPCKLDQ), MD_XMM_MEM128(PUNPCKLDQ), 1, 2)
    I$ = "PUNPCKLQDQ XMM, XMM" : Messung(ML_XMM_XMM(PUNPCKLQDQ), MD_XMM_XMM(PUNPCKLQDQ), 1, 2)
    I$ = "PUNPCKLQDQ XMM, MEM128" : Messung(ML_XMM_MEM128(PUNPCKLQDQ), MD_XMM_MEM128(PUNPCKLQDQ), 1, 2)
    I$ = "PXOR XMM, XMM" : Messung(ML_XMM_XMM(PXOR), MD_XMM_XMM(PXOR), 1, 2)  
    I$ = "PXOR XMM, MEM128" : Messung(ML_XMM_MEM128(PXOR), MD_XMM_MEM128(PXOR), 1, 2)
    I$ = "RCPPS XMM, XMM" : Messung(ML_XMM_XMM(RCPPS), MD_XMM_XMM(RCPPS), 1, 1)  
    I$ = "RCPPS XMM, MEM128" : Messung(ML_XMM_MEM128(RCPPS), MD_XMM_MEM128(RCPPS), 1, 1)
    I$ = "RCPSS XMM, XMM" : Messung(ML_XMM_XMM(RCPSS), MD_XMM_XMM(RCPSS), 1, 1)  
    I$ = "RCPSS XMM, MEM32" : Messung(ML_XMM_MEM32(RCPSS), MD_XMM_MEM32(RCPSS), 1, 1)
    I$ = "ROUNDPD XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(ROUNDPD, 3), MD_XMM_XMM_IMMFEST(ROUNDPD, 3), 1, 5)
    I$ = "ROUNDPD XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(ROUNDPD, 3), MD_XMM_MEM128_IMMFEST(ROUNDPD, 3), 1, 5)
    I$ = "ROUNDPS XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(ROUNDPS, 3), MD_XMM_XMM_IMMFEST(ROUNDPS, 3), 1, 5)
    I$ = "ROUNDPS XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(ROUNDPS, 3), MD_XMM_MEM128_IMMFEST(ROUNDPS, 3), 1, 5)
    I$ = "ROUNDSD XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(ROUNDSD, 3), MD_XMM_XMM_IMMFEST(ROUNDSD, 3), 1, 5)
    I$ = "ROUNDSD XMM, MEM64, Const8" : Messung(ML_XMM_MEM64_IMMFEST(ROUNDSD, 3), MD_XMM_MEM64_IMMFEST(ROUNDSD, 3), 1, 5)
    I$ = "ROUNDSS XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(ROUNDSS, 3), MD_XMM_XMM_IMMFEST(ROUNDSS, 3), 1, 5)
    I$ = "ROUNDSS XMM, MEM32, Const8" : Messung(ML_XMM_MEM32_IMMFEST(ROUNDSS, 3), MD_XMM_MEM32_IMMFEST(ROUNDSS, 3), 1, 5)
    I$ = "RSQRTPS XMM, XMM" : Messung(ML_XMM_XMM(RSQRTPS), MD_XMM_XMM(RSQRTPS), 1, 1)  
    I$ = "RSQRTPS XMM, MEM128" : Messung(ML_XMM_MEM128(RSQRTPS), MD_XMM_MEM128(RSQRTPS), 1, 1)
    I$ = "RSQRTSS XMM, XMM" : Messung(ML_XMM_XMM(RSQRTSS), MD_XMM_XMM(RSQRTSS), 1, 1)  
    I$ = "RSQRTSS XMM, MEM32" : Messung(ML_XMM_MEM32(RSQRTSS), MD_XMM_MEM32(RSQRTSS), 1, 1)
    I$ = "SHUFPD XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(SHUFPD, 3), MD_XMM_XMM_IMMFEST(SHUFPD, 3), 1, 2)
    I$ = "SHUFPD XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(SHUFPD, 3), MD_XMM_MEM128_IMMFEST(SHUFPD, 3), 1, 2)  
    I$ = "SHUFPS XMM, XMM, Const8" : Messung(ML_XMM_XMM_IMMFEST(SHUFPS, 3), MD_XMM_XMM_IMMFEST(SHUFPS, 3), 1, 1)
    I$ = "SHUFPS XMM, MEM128, Const8" : Messung(ML_XMM_MEM128_IMMFEST(SHUFPS, 3), MD_XMM_MEM128_IMMFEST(SHUFPS, 3), 1, 1)  
    I$ = "SQRTPS XMM, XMM" : Messung(ML_XMM_XMM(SQRTPS), MD_XMM_XMM(SQRTPS), 1, 1)  
    I$ = "SQRTPS XMM, MEM128" : Messung(ML_XMM_MEM128(SQRTPS), MD_XMM_MEM128(SQRTPS), 1, 1)
    I$ = "SQRTSD XMM, XMM" : Messung(ML_XMM_XMM(SQRTSD), MD_XMM_XMM(SQRTSD), 1, 1)  
    I$ = "SQRTSD XMM, MEM64" : Messung(ML_XMM_MEM64(SQRTSD), MD_XMM_MEM64(SQRTSD), 1, 1)    
    I$ = "SQRTSS XMM, XMM" : Messung(ML_XMM_XMM(SQRTSS), MD_XMM_XMM(SQRTSS), 1, 1)  
    I$ = "SQRTSS XMM, MEM32" : Messung(ML_XMM_MEM32(SQRTSS), MD_XMM_MEM32(SQRTSS), 1, 1)
    I$ = "SUBPD XMM, XMM" : Messung(ML_XMM_XMM(SUBPD), MD_XMM_XMM(SUBPD), 1, 2)
    I$ = "SUBPD XMM, MEM128" : Messung(ML_XMM_MEM128(SUBPD), MD_XMM_MEM128(SUBPD), 1, 2)   
    I$ = "SUBPS XMM, XMM" : Messung(ML_XMM_XMM(SUBPS), MD_XMM_XMM(SUBPS), 1, 1)
    I$ = "SUBPS XMM, MEM128" : Messung(ML_XMM_MEM128(SUBPS), MD_XMM_MEM128(SUBPS), 1, 1)   
    I$ = "SUBSD XMM, XMM" : Messung(ML_XMM_XMM(SUBSD), MD_XMM_XMM(SUBSD), 1, 2)  
    I$ = "SUBSD XMM, MEM64" : Messung(ML_XMM_MEM64(SUBSD), MD_XMM_MEM64(SUBSD), 1, 2)     
    I$ = "SUBSS XMM, XMM" : Messung(ML_XMM_XMM(SUBSS), MD_XMM_XMM(SUBSS), 1, 1)  
    I$ = "SUBSS XMM, MEM32" : Messung(ML_XMM_MEM32(SUBSS), MD_XMM_MEM32(SUBSS), 1, 1)    
    I$ = "UCOMISD XMM, XMM" : Messung(ML_XMM_XMM(UCOMISD), MD_XMM_XMM(UCOMISD), 1, 2)  
    I$ = "UCOMISD XMM, MEM64" : Messung(ML_XMM_MEM64(UCOMISD), MD_XMM_MEM64(UCOMISD), 1, 2)
    I$ = "UCOMISS XMM, XMM" : Messung(ML_XMM_XMM(UCOMISS), MD_XMM_XMM(UCOMISS), 1, 1)  
    I$ = "UCOMISS XMM, MEM32" : Messung(ML_XMM_MEM32(UCOMISS), MD_XMM_MEM32(UCOMISS), 1, 1)
    I$ = "UNPCKHPD XMM, XMM" : Messung(ML_XMM_XMM(UNPCKHPD), MD_XMM_XMM(UNPCKHPD), 1, 2)
    I$ = "UNPCKHPD XMM, MEM128" : Messung(ML_XMM_MEM128(UNPCKHPD), MD_XMM_MEM128(UNPCKHPD), 1, 2)   
    I$ = "UNPCKHPS XMM, XMM" : Messung(ML_XMM_XMM(UNPCKHPS), MD_XMM_XMM(UNPCKHPS), 1, 1)
    I$ = "UNPCKHPS XMM, MEM128" : Messung(ML_XMM_MEM128(UNPCKHPS), MD_XMM_MEM128(UNPCKHPS), 1, 1)
    I$ = "UNPCKLPD XMM, XMM" : Messung(ML_XMM_XMM(UNPCKLPD), MD_XMM_XMM(UNPCKLPD), 1, 2)
    I$ = "UNPCKLPD XMM, MEM128" : Messung(ML_XMM_MEM128(UNPCKLPD), MD_XMM_MEM128(UNPCKLPD), 1, 2)   
    I$ = "UNPCKLPS XMM, XMM" : Messung(ML_XMM_XMM(UNPCKLPS), MD_XMM_XMM(UNPCKLPS), 1, 1)
    I$ = "UNPCKLPS XMM, MEM128" : Messung(ML_XMM_MEM128(UNPCKLPS), MD_XMM_MEM128(UNPCKLPS), 1, 1)
    I$ = "XORPD XMM, XMM" : Messung(ML_XMM_XMM(XORPD), MD_XMM_XMM(XORPD), 1, 2)
    I$ = "XORPD XMM, MEM128" : Messung(ML_XMM_MEM128(XORPD), MD_XMM_MEM128(XORPD), 1, 2)   
    I$ = "XORPS XMM, XMM" : Messung(ML_XMM_XMM(XORPS), MD_XMM_XMM(XORPS), 1, 1)
    I$ = "XORPS XMM, MEM128" : Messung(ML_XMM_MEM128(XORPS), MD_XMM_MEM128(XORPS), 1, 1)
;--------------------------------------------------------------------------------------------------
    I$ = "FFREE" : Messung(F1ML_(FFREE), F1MD_(FFREE), 1, 10)   ;wird noch bentigt, deshalb vorn
    TicksFFree = TicksL  
    I$ = "FABS" : Messung(ML_(FABS), MD_(FABS), 0, 10)
    I$ = "FADD" : Messung(F2ML_(FADD), F2MD_(FADD), 1, 10)    
    I$ = "FCHS" : Messung(ML_(FCHS), MD_(FCHS), 0, 10)
    I$ = "FCLEX" : Messung(ML_(FCLEX), MD_(FCLEX), 0, 10)
    I$ = "FNCLEX" : Messung(ML_(FNCLEX), MD_(FNCLEX), 0, 10)
    I$ = "FCOM" : Messung(F1ML_(FCOM), F1MD_(FCOM), 1, 10)
    I$ = "FCOS" : Messung(ML_(FCOS), MD_(FCOS), 0, 10)
    I$ = "FDIV" : Messung(F2ML_(FDIV), F2MD_(FDIV), 1, 10)     
    I$ = "FDIVR" : Messung(F2ML_(FDIVR), F2MD_(FDIVR), 1, 10)    
    I$ = "FINIT" : Messung(ML_(FINIT), MD_(FINIT), 0, 10)
    I$ = "FNINIT" : Messung(ML_(FNINIT), MD_(FNINIT), 0, 10)
    I$ = "FMUL" : Messung(F2ML_(FMUL), F2MD_(FMUL), 1, 10)  
    I$ = "FNOP" : Messung(ML_(FNOP), MD_(FNOP), 0, 10)
    I$ = "FPREM" : Messung(ML_(FPREM), MD_(FPREM), 0, 10)
    I$ = "FPREM1" : Messung(ML_(FPREM1), MD_(FPREM1), 0, 10)
    I$ = "FRNDINT" : Messung(ML_(FRNDINT), MD_(FRNDINT), 0, 10)
    I$ = "FSCALE" : Messung(ML_(FSCALE), MD_(FSCALE), 0, 10)
    I$ = "FSIN" : Messung(ML_(FSIN), MD_(FSIN), 0, 10)
    I$ = "FSQRT" : Messung(ML_(FSQRT), MD_(FSQRT), 0, 10)
    I$ = "FSUB" : Messung(F2ML_(FSUB), F2MD_(FSUB), 1, 10)    
    I$ = "FSUBR" : Messung(F2ML_(FSUBR), F2MD_(FSUBR), 1, 10)     
    I$ = "FTST" : Messung(ML_(FTST), MD_(FTST), 0, 10)
    I$ = "FWAIT" : Messung(ML_(FWAIT), MD_(FWAIT), 0, 10)
    I$ = "FXAM" : Messung(ML_(FXAM), MD_(FXAM), 0, 10)     
    I$ = "F2XM1" : Messung(ML_(F2XM1), MD_(F2XM1), 0, 10)
    I$ = "FLD ST" : Messung(F5ML_(), F1MD_(FLD), 0, 10)
    L1$ = StrD(TicksL - TicksFFree, 2)         
    L$ = Space(2 * (7 - Len(L1$))) + L1$
  ;D1$ = StrD(TicksD, 2)
  ;D$ = Space(2 * (7 - Len(D1$))) + D1$
    SetGadgetItemText(0, z - 1, L$, 1)
  ;SetGadgetItemText(0, z, D$, 2) 
    
    I$ = "FLD MEM64" : Messung(F3ML_(), F1MD_(FLD), 0, 10)
    L1$ = StrD(TicksL - TicksFFree, 2)         
    L$ = Space(2 * (7 - Len(L1$))) + L1$
  ;D1$ = StrD(TicksD, 2)
  ;D$ = Space(2 * (7 - Len(D1$))) + D1$
   SetGadgetItemText(0, z - 1, L$, 1)
  ;SetGadgetItemText(0, z, D$, 2)         
    

    ;Fertig
    VirtualFreeEx_(GetCurrentProcess_(), CodeMemUr, Mem, #MEM_DECOMMIT)
   Else
    MessageRequester("Fehler !", "Der bentigte Speicher konnte nicht bereitgestellt werden !")
  EndIf

  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_Menu
        Select EventMenu()
          Case 1                            ;Speichern im Code-Verzeichnis
            DeleteFile("LD.txt") 
            OpenFile(0, "LD.txt")
            For i = 0 To z                  ;Windows-Editor: Nicht-Proportional-Schrift! Z.B. Courier
              S1$ = GetGadgetItemText(0, i, 0)
              S2$ = GetGadgetItemText(0, i, 1)
              S3$ = GetGadgetItemText(0, i, 2)
              S1$ = S1$ + Space(50 - Len(S1$) - Len(S2$))
              E$ = Space(2) + S1$
              S2$ = S2$ + Space(10 - Len(S3$))
              E$ + S2$
              E$ + S3$
              WriteStringN(0, E$)
              WriteStringN(0, "  ------------------------------------------------------------")
            Next
            CloseFile(0)       
          Case 2                            ;Speicher-Verzeichnis und -Namen festlegen 
            Pattern$ = "Alle Dateien (*.*)|*.*"
            Pattern = 0 
            File$ = SaveFileRequester("Bitte Datei zum Speichern auswhlen", "*.*", Pattern$, Pattern)
            OpenFile(0, File$)
            For i = 0 To z                  ;Windows-Editor: Nicht-Proportional-Schrift! Z.B. Courier
              S1$ = GetGadgetItemText(0, i, 0)
              S2$ = GetGadgetItemText(0, i, 1)
              S3$ = GetGadgetItemText(0, i, 2)
              S1$ = S1$ + Space(50 - Len(S1$) - Len(S2$))
              E$ = Space(2) + S1$
              S2$ = S2$ + Space(10 - Len(S3$))
              E$ + S2$
              E$ + S3$
              WriteStringN(0, E$)
              WriteStringN(0, "------------------------------------------------------------")
            Next
            CloseFile(0)       
          Case 3                            ;Drucken   Ohne Gewhr! Evtl. fr eigenen Drucker anpassen!
 
            If PrintRequester()
              LRA = PrinterPageWidth() / 10      ;4800  linker Rand  500
              ORA = PrinterPageHeight() / 70     ;6826  oberer Rand  100
              ZAB = PrinterPageHeight() / 30     ;6826  Zeilenabstand  250
              If StartPrinting("CPU - Latenz/Durchsatz - Messung")
                LoadFont(0, "Courier New", 60, #PB_Font_Underline); | #PB_Font_Bold)  ; Nicht-Proportional-Schrift! Z.B. Courier
                If StartDrawing(PrinterOutput())
                  DrawingFont(FontID(0))
                  While j < z    
                    DrawText(LRA, ORA, "     Befehl                                  Latenz   Durchsatz")
                    k = 0                
                    For i = j To 59 + j
                      S1$ = GetGadgetItemText(0, i, 0)
                      S2$ = GetGadgetItemText(0, i, 1)
                      S3$ = GetGadgetItemText(0, i, 2)
                      E$ = S1$ + Space(50 - Len(S1$) - Len(S2$))
                      S2$ = S2$ + Space(10 - Len(S3$))
                      E$ + S2$
                      E$ + S3$
                      DrawText(LRA, (k * ORA) + ZAB, E$)   
                      If i = z
                        StopDrawing()
                        StopPrinting()
                        Break 2
                      EndIf 
                      k + 1
                    Next
                    If i < z
                      NewPrinterPage() 
                    EndIf 
                    j + 60    
                  Wend 
                EndIf
              EndIf
            EndIf
          Case 4                            ;Beenden
            Quit = 1
        EndSelect

      Case #PB_Event_CloseWindow
        Quit = 1
    EndSelect
  Until Quit = 1

EndIf

End

;--------------------------------------------------------------------------------------------------
;Floats (Doubles) werden hier auch als Integers "missbraucht" !
;1 Float wird als ein "halbes" Double eingelesen; der Wert ist zwar sinnlos, aber ungefhrlich
!section '.data' Data readable writeable

!MemAli    DQ 1234567890.0   ;zum Lesen, ist (mindestens) 16-Byte-aligned, Start=0
!          DQ 0987654321.0
!          DQ 2345678901.0 
!          DQ 1098765432.0
!          DQ 3456789012.0 
!          DQ 2109876543.0
!          DQ 4567890123.0 
!          DQ 3210987654.0
!          DQ 5678901234.0 
!          DQ 4321098765.0
!          DQ 6789012345.0
!          DQ 5432109876.0 
!          DQ 7890123456.0
!          DQ 6543210987.0 
!          DQ 8901234567.0
!          DQ 7654321098.0

!          DQ 16 DUP ?       ;zum Beschreiben, ist (mindestens) 16-Byte-aligned, Start=128

!          DD 12345.0        ;zum Lesen, ist (mindestens) 16-Byte-aligned, Start=256
!          DD 09876.0
!          DD 23456.0 
!          DD 10987.0
!          DD 34567.0 
!          DD 21098.0
!          DD 45678.0 
!          DD 32109.0

!          DB ?              ;Alignment zerstren; Start=288

!MemNoAli  DQ 1234567890.0   ;fr Messung mit Non-Alignment, Start=289
!          DQ 0987654321.0
!          DQ 2345678901.0 
!          DQ 1098765432.0
!          DQ 3456789012.0 
!          DQ 2109876543.0
!          DQ 4567890123.0 
!          DQ 3210987654.0
!          DQ 5678901234.0 
!          DQ 4321098765.0
!          DQ 6789012345.0
!          DQ 5432109876.0 
!          DQ 7890123456.0
!          DQ 6543210987.0 
!          DQ 8901234567.0
!          DQ 7654321098.0

!          DB 15 DUP ?       ;Alignment wieder herstellen, mal so lassen

!          DD 12345          ;Integer dword lesen , Start=432
!          DD 09876
!          DD 23456 
!          DD 10987
!          DD 34567 
!          DD 21098
!          DD 45678 
!          DD 32109

!          DD 8 DUP ?        ;Integer dword schreiben , Start=464     
;Ende=496